﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CS_Unidad_10
{
    // una clase Empleado para probar
    // conversiones de listas
    public class Empleado : IComparable<Empleado>
    {
        private string Nombre;
        private int NumeroEmpleado;

        public Empleado() { }
        public Empleado(string nombre)
        {
            Nombre = nombre;
        }
        public Empleado(string nombre, int numeroEmpleado)
        {
            Nombre = nombre;
            NumeroEmpleado = numeroEmpleado;
        }
        // Métodos públicos
        public string LeerNombre()
        {
            return Nombre;
        }

        public int LeerNumeroEmpleado()
        {
            return NumeroEmpleado;
        }

        public override String ToString()
        {
            // se implementa el método ToString para
            // devolver la representación en cadena
            // de un campo significativo del objeto
            // el campo es de elección libre del
            // diseñador de la clase
            return Nombre;
        }

        // La interfaz IComparable nos obliga a implementar
        // el método CompareTo()
        public int CompareTo(Empleado emp)
        {
            // La elección de qué se compara en una
            // clase personalizada como esta es totalmente
            // libre. Aquí elegimos comparar por NúmeroEmpleado
            // pero podríamos haber elegido comparar por nombre
            // o, si hubiera el campo, por sueldo o fecha de ingreso, etc.

            return (NumeroEmpleado.CompareTo(emp.NumeroEmpleado));
        }
    }
}
