﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace CS_Unidad_10
{
   
    class Program
    {
         
        static void Main(string[] args)
        {
            Console.WriteLine("Prácticas de la unidad 10: Colecciones y listas");
            Console.WriteLine("-----------------------------------------------");

            // ejemplo de genéricos
            U1000();

            // Añadido y eliminación de elementos a una lista
            U1001();

            // Búsquedas en una lista
            U1002();

            // Copia de listas
            U1003();

            // Conversiones de listas
            U1004();

            // Manipulaciones sobre una lista
            U1005();

            // Clasificación de listas
            U1006();

            // Método genérico
            U1007();

            // Otros tipos de colecciones (Queue)
            U1008();

            // Otros tipos de colecciones (Stack)
            U1009();

            // Otros tipos de colecciones (Dictionary)
            U1010();
        }

        static void U1000()
        {
            Console.WriteLine("Ejemplo U1000()");
            Console.WriteLine("--------------");

            Console.WriteLine("Introducción a la genericidad");
            Console.WriteLine("-----------------------------");

            var nombres = new ListaNombres();
            nombres.Add("González, Horacio");
            nombres.Add("Nani Rodriguez");
            nombres.Add(100.ToString());
           
            nombres.Listar();

            var números = new ListaNúmeros();
            números.Add(120);
            números.Add(99);
            números.Listar();

            var objetos = new ListaObjetos();
            objetos.Add("Carlos Pérez Zeus");
            objetos.Add("Celia Quiroga");
            objetos.Add(1500);
            objetos.Listar();

            
            // Una lista genérica de cadenas de .NET
            var ciudades = new List<string>() { "París", "Roma", "Nueva York" };
            ciudades.Add("Lima");
            foreach (var ciudad in ciudades)
            {
                Console.WriteLine("Listado de ciudades: " + ciudad);
            }

            // Una lista genérica de números enteros de .NET
            var enteros = new List<int>() { 10, 30, 2, 55 };
            enteros.Add(44);
            foreach (var entero in enteros)
            {
                Console.WriteLine("Listado de enteros: " + entero);
            }

        }
        static void U1001()
        {
            Console.WriteLine("Ejemplo U1001()");
            Console.WriteLine("--------------");

            Console.WriteLine("Añadido y eliminación de elementos a una lista");

            //  creación sin asignación
            var cadenas = new List<string>();

            // creación con asignación
            var ciudades = new List<string>() { "París", "Roma", "Nueva York"};
            Listar(1, ciudades);

            // añadir elementos
            Console.WriteLine("Añadir 2 elementos");
            ciudades.Add("México");
            ciudades.Add("Atenas");
            Listar(2, ciudades);

            // añadir rango de elementos
            Console.WriteLine("Añadir rango de elementos");
            ciudades.AddRange(new string[2] { "Montevideo", "Berlín" });
            Listar(3, ciudades);

            // Eliminar por contenido
            Console.WriteLine("Eliminar México");
            ciudades.Remove("México");
            Listar(4, ciudades);

            // Eliminar por índice
            Console.WriteLine("Eliminar por índice, el 3");
            ciudades.RemoveAt(3);
            Listar(5, ciudades);

            // uso de predicado
            // para eliminar las ciudades
            // con más de 6 letras
            Console.WriteLine("Eliminar condicionado: si > a 6 letras");
            ciudades.RemoveAll(MasDe6Letras);
            Listar(6, ciudades);

            // Insertar un elemento en el índice 2
            Console.WriteLine("Insertar Sidney en índice 2");
            ciudades.Insert(2, "Sidney");
            Listar(7, ciudades);

            // Insertar un rango de elementos en el índice 1
            Console.WriteLine("Insertar rango en índice 1");
            ciudades.InsertRange(1, new string[] { "La Paz", "Girona", "El Cairo" });
            Listar(8, ciudades);

            // Eliminar todo
            Console.WriteLine("Eliminar toda la lista");
            ciudades.Clear();           

            Console.WriteLine("--Fin del ejemplo--");
        }

        static void U1002()
        {
            Console.WriteLine("Ejemplo U1002()");
            Console.WriteLine("--------------");

            Console.WriteLine("Búsquedas en una lista");
            var ciudades = new List<string>() { "Barcelona", "Roma", "Berlín", "Melbourne" };

            Console.WriteLine("Índice/Contenido con for()");
            for (var i = 0; i < ciudades.Count; i++)
                Console.WriteLine("índice {0}: contiene {1}", i, ciudades[i]);            
            Console.WriteLine("Total de elementos." + ciudades.Count);           

            Console.WriteLine("Índice/Contenido con foreach()");
            foreach (var c in ciudades)           
                Console.WriteLine("Índice: {0}: contiene {1}",ciudades.IndexOf(c), c);
            Console.WriteLine("Total de elementos." + ciudades.Count);

            // Verificar por contenido
            if (ciudades.Contains("Roma"))
                Console.WriteLine("Contains(): Contiene Roma");

            // Verificar si se cumple una condición
            // uso del predicado MasDe6Letras
            // Exists(): verifica una condición
            if (ciudades.Exists(MasDe6Letras))
            {
                Console.WriteLine("Exists(): sí hay alguna ciudad de más de 6 letras");
                // Find(): encontrar el primer elemento que cumpla la condición
                Console.WriteLine("1ra. ciudad de + de 6 letras " + ciudades.Find(MasDe6Letras));
                // FindLast(): encontrar el primer elemento que cumpla la condición
                Console.WriteLine("Última ciudad de + de 6 letras " + ciudades.FindLast(MasDe6Letras));
            }
            else
                Console.WriteLine("Exists(): no sí hay ninguna ciudad de más de 6 letras");

            // se crea una lista con los elementos que
            // cumplen una condición
            Console.WriteLine("Uso de FindAll, FindIndex, FindLastIndex");
            var ciudadesConB = ciudades.FindAll(EmpiecenConB);
            Listar(8, ciudadesConB);

            int ind = ciudades.FindIndex(EmpiecenConB);
            Console.WriteLine("Primera ciudad que empieza con B " + ciudades[ind]);

            ind = ciudades.FindLastIndex(EmpiecenConB);
            Console.WriteLine("Última ciudad que empieza con B " + ciudades[ind]);

            // Búsqueda en lista ordenada
            // devuelve 0 si el elemento existe
            // si no existe:
            // devuelve el número negativo que es el complemento bit a bit
            // del índice del primer elemento mayor a Dublín o, si no hay
            // ninguno mayor, será el complemento bit a bit de Count
            ciudades.Sort();
            Listar(9, ciudades);

            // Búsqueda binaria de un elemento
            int index = ciudades.BinarySearch("Dublín");
           
            // como Dublín no existe en index nos queda el valor de 
            // Melbourne que tiene índice 2 pero queda en negativo
            // con el operador ~ se invierte el signo y se puede usar 
            // como índice; de esa manera, Dublín se intercalará entre 
            // Berlín y Melbourne
            if (index < 0)            
                ciudades.Insert(~index, "Dublín");
            Listar(10, ciudades);

            // En la búsqueda de Seúl:
            // el resultado es que no existe...
            // pero Seúl es mayor a Roma (la
            // última de la lista) 
            // en este caso, en index nos quedará el 
            // valor de Count en negativo y lo
            // usamos para insertar

            // Búsqueda binaria de un elemento
            index = ciudades.BinarySearch("Seúl");

            if (index < 0)
                ciudades.Insert(~index, "Seúl");
            Listar(11, ciudades);
            Console.WriteLine("--Fin del ejemplo--");
        }

        static void U1003()
        {
            Console.WriteLine("Ejemplo U1003()");
            Console.WriteLine("--------------");

            Console.WriteLine("Copia de listas");
             
            var nros = new List<int>() { 9, 8, 4, 11, 14, 0 };

            Console.WriteLine("AsReadOnly(): una copia de sólo lectura");
            IList<int> listaSoloLectura = nros.AsReadOnly();
            // si analizamos los métodos disponibles
            // en la instancia listaSoloLectura
            // veremos que no hay métodos de 
            // modificación de la lista

            // en cambio, si cambiamos
            // el contenido de la lista original
            Console.WriteLine("Modificación de la lista original...");
            nros[0] = 9999;

            // vemos que automáticamente también modifica 
            // listaSoloLectura
            Console.WriteLine("AsReadOnly(): se sincroniza la copia de sólo Lectura");
            foreach(var i in listaSoloLectura)
                Console.WriteLine("Valor: " + i);

            Console.WriteLine("CopyTo(): copia total o parcial a matriz");
            // Copia total o parcial de una lista en una matriz
            // unidimensional compatible
            int[] matriz = new int[10];

            // Copia total
            nros.CopyTo(matriz);
            Console.WriteLine("CopyTo: copia completa - Listado 1");
            Console.WriteLine("Esta matriz tiene más capacidad que la lista... " );
            Console.WriteLine("por lo tanto, quedarán elementos en cero");
            foreach(var  i in matriz)
                Console.WriteLine(i);

            Console.WriteLine("Limpieza de la matriz");
            Array.Clear(matriz,0,10);
            // Copia total a partir
            // de la posición 4 de la matriz
            // de destino
            Console.WriteLine("CopyTo: copia total con desplazamiento de índice - Listado 2");
            nros.CopyTo(matriz, 4);           
            foreach (var i in matriz)
                Console.WriteLine(i);

            Console.WriteLine("Limpieza de la matriz");
            Array.Clear(matriz, 0, 10);
            // Copia de un intervalo
            // desde el índice 3 en la lista
            // al índice 8 en la matriz
            // y una cantidad de elementos
            // especificados (2)
            Console.WriteLine("CopyTo: copia parcial con desplazamiento de índice - Listado 3");
             nros.CopyTo(3, matriz, 8, 2);
            foreach (var i in matriz)
                Console.WriteLine(i);

            // uso de GetRange()
            // para tener una copia total o parcial
            // de una lista
            Console.WriteLine("GetRange(): copia superficial (parcial)");
            List<string> miCadena = new List<String>() { "A", "B", "C", "D" };
            List<string> miRango = miCadena.GetRange(0, 3);
            Listar(12, miRango);
            Console.WriteLine("Comprobamos que comparten referencias");
            Console.WriteLine("References: " + Object.ReferenceEquals(miCadena[0], miRango[0]));
            Console.WriteLine("Mientras no haya modificaciones comparten referencias");

            // Modificamos el original
            // y comprobamos que la copia no se modifica
            // porque ya no comparten referencia
            Console.WriteLine("Pero al modificar el original ya no compartirán referencias");
            miCadena[0] = "X";           
            Listar(13, miCadena);
            Console.WriteLine("Y ahora comprobamos que ya no comparten referencias");
            Console.WriteLine("References: " + Object.ReferenceEquals(miCadena[0], miRango[0]));            

            Console.WriteLine("Limpieza de toda la lista");
            miCadena.Clear();  

            Console.WriteLine("--Fin del ejemplo--");
        }

        static void U1004()
        {
            Console.WriteLine("Ejemplo U1004()");
            Console.WriteLine("--------------");

            Console.WriteLine("Conversiones de listas");

            // tenemos una lista de nombres
            List<String> personas = new List<String>();
            personas.Add("Martínez Rafael");
            personas.Add("Gómez Inés");
            personas.Add("Botella José");
            personas.Add("Font Celeste");

            Console.WriteLine("Contenido de la lista personas");
            Listar(15, personas);

            // GetRange() para convertir toda la lista
            // a una matriz
            // GetRange(): conversión de toda una lista a matriz
            Console.WriteLine("GetRange(): conversión de toda la lista a matriz");
            string[] miMatriz = personas.GetRange(0, personas.Count).ToArray();
            Console.WriteLine("Listado de la matriz resultante de la conversión");
            foreach (var i in miMatriz)
                Console.WriteLine(i);

            // GetRange() para convertir parte de la lista
            // a una matriz (sólo índice 1 y 2)
            // GetRange(): conversión de toda una lista a matriz
            Console.WriteLine("GetRange(): conversión de parte de la lista a matriz");
            string[] miMatrizParcial = personas.GetRange(1, 2).ToArray();
            Console.WriteLine("Listado de la matriz resultante de la conversión");
            foreach (var i in miMatrizParcial)
                Console.WriteLine(i);

            // Convertir una lista de String en
            // una lista de otro tipo

            Console.WriteLine("Uso del método ConvertAll()");
            // la convertiremos en una lista de
            // clase Empleado con la ayuda
            // del convertidor ConvertirAEmpleado
            List<Empleado> listEmpleado = personas.ConvertAll(
                new Converter<String, Empleado>(ConvertirAEmpleado));

            // Listar la nueva lista
            Console.WriteLine("Lista de empleados");
            foreach (var c in listEmpleado)
                Console.WriteLine(c.ToString());            

            Console.WriteLine("--Fin del ejemplo--");
        }

        static void U1005()
        {
            Console.WriteLine("Ejemplo U1005()");
            Console.WriteLine("--------------");

            Console.WriteLine("Clasificación de listas");
            var nros = new List<int>() { 9, 8, 4, 11, 14, 0 };

            Console.WriteLine("Lista original sin ordenar");
            Listar(14, nros);
            
            // Ordenar los 3 últimos elementos
            Console.WriteLine("Sort(): Ordenamiento de los últimos 3 elementos");
            nros.Sort(nros.Count - 3, 3, null);
            Listar(15, nros);

            // Ordenar todo
            Console.WriteLine("Sort(): Ordenamiento de toda la lista");
            nros.Sort();
            Listar(16, nros);

            // revertir los 4 últimos
            Console.WriteLine("Reverse(): Reversión de los últimos 4 elementos");
            nros.Reverse(nros.Count - 4, 4);
            Listar(17, nros);

            Console.WriteLine("--Fin del ejemplo--");
        }
        

        static void U1006()
        {
            Console.WriteLine("Ejemplo U1006()");
            Console.WriteLine("--------------");
            Console.WriteLine("Trabajos sobre listas");

            // Valores dentro del rango 1 a 100
            List<float> precios = new List<float> { 12.50f, 28.90f, 35.85f, 85.90f };

            Console.WriteLine("TrueForAll(): verificaciones sobre una lista");
            if (precios.TrueForAll(ComprobarRango))
                Console.WriteLine("OK. Todos los elementos de la lista están dentro del rango");

            // añadimos un elemento que estará fuera
            // del rango 1 a 100
            Console.WriteLine("Forzamos un elemento a que esté fuera del rango...");
            precios.Add(150.00f);

            if (!precios.TrueForAll(ComprobarRango))
                Console.WriteLine("Al menos un elemento de la lista está fuera del rango!!");

            Console.WriteLine("TrimExcess(): Control de Capacidad y Cantidad de elementos");
            List<int> enteros = new List<int>();
            Console.WriteLine("Inserción de 600 elementos");
            for (var cont = 0; cont < 600; cont++)
                enteros.Add(cont);

            Console.WriteLine("Capacity :" + enteros.Capacity);
            Console.WriteLine("Count :" + enteros.Count);
            
            Console.WriteLine("Eliminación de 595 elementos");
            enteros.RemoveRange(0, 595);
            Console.WriteLine("Mantiene la misma capacidad");
            Console.WriteLine("Capacity :" + enteros.Capacity);
            Console.WriteLine("Count :" + enteros.Count);

            Console.WriteLine("Aplicación de TrimExcess()");
            Console.WriteLine("Recorta la capacidad innecesaria");
            enteros.TrimExcess();
            Console.WriteLine("Capacity :" + enteros.Capacity);
            Console.WriteLine("Count :" + enteros.Count);

            Console.WriteLine("ForEach()");
            Console.WriteLine("Impresión de valores pares");
            enteros.ForEach(Imprimir);    
            Console.WriteLine("--Fin del ejemplo--");
           
        }
        static bool ComprobarRango(float precio)
        {
            return (precio >= 1 & precio <= 100);
        }
        static void Imprimir(int valor)
        {
            if (valor % 2 == 0)
                Console.WriteLine("Imprime par " + valor);
        }
        static void U1007()
        {
            Console.WriteLine("Ejemplo U1007()");
            Console.WriteLine("---------------");

            Console.WriteLine("Métodos genéricos");
            Console.WriteLine("-----------------");

            // Utilizamos varios tipos para probar el 
            // método genérico Menor()
            char char1 = Menor('x', 'z');
            string str1 = Menor("Europa", "América");
            float float1 = Menor(80.5f, 90.6f);
            int int1 = Menor(15, 150);

            Console.WriteLine("Menores: {0}; {1}; {2}; {3}", char1, str1, float1, int1);

            // Método genérico utilizado
            // en una clase personalizada
            // la clase Empleado para utilizar
            // el método Menor() "DEBERÁ" implementar
            // IComparable, sino no compilará
            var emp1 = new Empleado("Albert", 1800);
            var emp2 = new Empleado("Rosa", 500);
            var emp3 = Menor(emp1, emp2);

            Console.WriteLine("Empleado con nro.menor: " +
                emp3.LeerNombre() + "  nro." + emp3.LeerNumeroEmpleado());

            Console.WriteLine("--Fin del ejemplo--");
        }

        static T Menor<T>(T valor1, T valor2) where T : IComparable<T>
        {
            if (valor1.CompareTo(valor2) < 0) return valor1;
            return valor2;
        }

        static void Listar<T>(int idListado, List<T> lista)
        {
            Console.WriteLine("Listado nro. {0}", idListado);
            Console.WriteLine("----------------");
            foreach(var c in lista)
            {
                Console.Write("{0} ", c);
            }
            Console.WriteLine("\nTotal de elementos." + lista.Count);
            Console.WriteLine("--------------------------");
        }
      
        static bool MasDe6Letras(String s)
        {
            return s.Length > 6;
        }

        static bool EmpiecenConB(String s)
        {
            return s.StartsWith('B');
            
        }

        // Método que realiza la conversión
        static Empleado ConvertirAEmpleado(String str)
        {
            // convierte un nombre
            // en un objeto Empleado
            return new Empleado(str);
        }
        static void U1008()
        {
            Console.WriteLine("Ejemplo U1008()");
            Console.WriteLine("---------------");

            Console.WriteLine("Colecciones");
            Console.WriteLine("-----------");

            Console.WriteLine("Colección Queue");
            // Colas FIFO
            Queue miCola = new Queue();
            miCola.Enqueue("Ramón García Ramos");
            miCola.Enqueue("Ana Rosa Jiménez Fuente");
            miCola.Enqueue("Irene Montsant ´Fernández");
            miCola.Enqueue("Pol Pons Ginovart");

            Console.WriteLine("Sale el más viejo y lo quita de la cola {0} ", miCola.Dequeue());
            Console.WriteLine("Muestra el más viejo y lo deja de la cola {0} ", miCola.Peek());

            Console.WriteLine("Listado de la cola");
            foreach (var cola in miCola)
                Console.WriteLine("personas en la cola: {0}", cola);
            Console.WriteLine("--Fin del ejemplo--");

        }
        static void U1009() {

            Console.WriteLine("Ejemplo U1009()");
            Console.WriteLine("---------------");

            Console.WriteLine("Colecciones");
            Console.WriteLine("-----------");

            Console.WriteLine("Colección Stack");
            // Colas LIFO
            Stack miPila = new Stack();

            miPila.Push("Italia");
            miPila.Push("España");
            miPila.Push("Francia");
            miPila.Push("México");

            Console.WriteLine("Elemento que saldría con Pop(): {0}", miPila.Peek());
            
            Console.WriteLine("Añado otro elemento (Irlanda)");
            miPila.Push("Irlanda");

            Console.WriteLine("Elemento que saldría con Pop(): {0}", miPila.Peek());
            Console.WriteLine("Cola LIFO sale el último elemento añadido {0} ", miPila.Pop());
            Console.WriteLine("Ahora el siguiente a salir sería {0} ", miPila.Peek());
            
            Console.WriteLine("Listado de la pila");
            foreach (var país in miPila)
                Console.WriteLine("Países en la pila: {0}", país);

            Console.WriteLine("--Fin del ejemplo--");
        }
        static void U1010() {
            Console.WriteLine("Ejemplo U1010()");
            Console.WriteLine("---------------");

            Console.WriteLine("Colecciones");
            Console.WriteLine("-----------");

            Console.WriteLine("Colección Dictionary<TKey>, <TValue>");

            // Dictionary<TKey, TValue>
            Console.WriteLine("Dictionary<TKey, TValue>: ejemplo diccionario multiidioma");

            // para usar en una interfaz que permite seleccionar el idioma
            Console.WriteLine("Creación del diccionario con cuatro idiomas");

            Dictionary<int, string> multiDicc = new Dictionary<int, string>();
            // se reservan 1000 mensajes para cada idioma
            // como ejemplo, creamos 3 por idioma

            // castellano de 0 a 999
            multiDicc.Add(0, "Lo siento, mensaje no implementado");
            multiDicc.Add(1, "Para copiar pulsar Ctrl+C");
            multiDicc.Add(2, "Para cortar pulsar Crtl+X");
            multiDicc.Add(3, "Para pegar pulsar Crtl+V");

            // italiano de 1000 a 1999
            multiDicc.Add(1000, "Siamo spiacenti, messaggio non implementato");
            multiDicc.Add(1001, "Per copiare premere Ctrl+C");
            multiDicc.Add(1002, "Per tagliare premere Crtl+X");
            multiDicc.Add(1003, "Per incollare prémer Crtl+V");

            // catalán de 2000 a 2999
            multiDicc.Add(2000, "Ho sento, missatge no implementat");
            multiDicc.Add(2001, "Per copiar prémer Ctrl+C");
            multiDicc.Add(2002, "Per tallar prémer Crtl+X");
            multiDicc.Add(2003, "Per enganxar prémer Crtl+V");

            // inglés de 3000 a 3999
            multiDicc.Add(3000, "Sorry, message not implemented");
            multiDicc.Add(3001, "To copy press Ctrl+C");
            multiDicc.Add(3002, "To cut press Crtl+X");
            multiDicc.Add(3003, "To paste press Crtl+V");

            // supongamos que el usuario es de Italia
            string idiomaSeleccionado = "Italiano";
            int índice;

            // en base al idioma elegido se posiciona el índice
            // en el primer mensaje del idioma
            switch (idiomaSeleccionado)
            {
                case "Castellano":
                    índice = 0;
                    break;
                case "Italiano":
                    índice = 1000;
                    break;
                case "Catalán":
                    índice = 2000;
                    break;
                case "Inglés":
                    índice = 3000;
                    break;
                default:
                    // por defecto, se selecciona Castellano
                    índice = 0;
                    break;
            }

            Console.WriteLine("Listado completo del diccionario");
            foreach(var dicc in multiDicc)
                Console.WriteLine("Clave: {0}, Valor: {1}", dicc.Key, dicc.Value);

            Console.WriteLine("Listado del diccionario " + idiomaSeleccionado);
            foreach (var dicc in multiDicc)
            {
                // lista sólo el texto del idioma seleccionado
                if (dicc.Key >= índice & dicc.Key <= índice + 999)
                   Console.WriteLine("Clave: {0}, Valor: {1}", dicc.Key, dicc.Value);
            }

            // supongamos que se quiere emitir el mensaje nro.2
            // en el idioma elegido
            // producción del mensaje 
            Console.WriteLine("Producción del mensaje nro.2 en el idioma elegido: {0}", idiomaSeleccionado);
            
            string valor;
            if (multiDicc.TryGetValue(índice + 2, out valor))
                Console.WriteLine(valor);
            else
                Console.WriteLine(multiDicc[índice]);

            Console.WriteLine("Otra alternativa de codificación de lo mismo...");
            // Otra manera de asegurarnos el mensaje
            // sin crear excepciones
            if (multiDicc.ContainsKey(índice + 2))
                Console.WriteLine(multiDicc[índice + 2]);
            else
                Console.WriteLine(multiDicc[índice]);            

            Console.WriteLine("--Fin del ejemplo--");
        }
    }
}
