﻿using System;
using System.Diagnostics.CodeAnalysis;
using System.Globalization;

namespace CS_Unidad_11
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("-----------------------------");
            Console.WriteLine("--Prácticas de la Unidad 11--");
            Console.WriteLine("-----------------------------");

            // Formas de creación de fechas
            U1101();

            // Operaciones de suma y resta
            U1102();

            // Operaciones de diferencia de fechas
            U1103();


            // Trabajo con Ticks
            U1104();

            // Presentación de las fechas con formato estándar
            U1105();

            // Presentación de las fechas con formato específico
            U1106();

            // Creación de objetos TimeSpan
            U1107();

            // Revisión de las propiedades de TimeSpan
            U1108();

            // Operaciones aritméticas con objetos TimeSpan
            U1109();

        }
        static void U1101()
        {
            Console.WriteLine("--U1101()--");
            Console.WriteLine("--Creación con los constructores de DateTime--");
            Console.WriteLine("----------------------------------------------");
            // Creación de fechas y horas

            // fecha del 30/7/2020 8:30:00 AM
            var fechaHora1 = new DateTime(2020, 7, 30, 8, 30, 0);
            Console.WriteLine("Fecha --> " + fechaHora1);

            // fecha del 30/7/2020 0:00:00 AM
            // al no informarse hh:mm:ss
            // se asume 00:00:00
            var fechaHora2 = new DateTime(2020, 7, 30);
            Console.WriteLine("Fecha --> " + fechaHora2);

            // uso de campos de DateTime
            var ahora = DateTime.Now;
            Console.WriteLine("Fecha --> " + ahora);

            // uso de campos de DateTime
            // Today = Now pero con hora 00:00:00
            var hoy = DateTime.Today;
            Console.WriteLine("Fecha --> " + hoy);
        }
        static void U1102()
        {
            Console.WriteLine("--U1102()--");
            Console.WriteLine("--DateTime--");
            Console.WriteLine("---------------------------");
            // En la configuración vigente se asume GregorianCalendar y DateTime.Local
            var fechaHora = new DateTime(2021, 3, 30, 08, 30, 50, 555, new GregorianCalendar(), DateTimeKind.Utc);
            Console.WriteLine("Formateos predeterminados");
            Console.WriteLine("-------------------------");
            Console.WriteLine("Fecha larga " + fechaHora.ToLongDateString());
            Console.WriteLine("Hora larga " + fechaHora.ToLongTimeString());
            Console.WriteLine("Fecha corta " + fechaHora.ToShortDateString());
            Console.WriteLine("Hora corta " + fechaHora.ToShortTimeString());

            Console.WriteLine("Propiedades de DateTime");
            Console.WriteLine("-----------------------");
            Console.WriteLine("Día de la semana " + fechaHora.DayOfWeek);
            Console.WriteLine("Día del año: " + fechaHora.DayOfYear);
            Console.WriteLine("Hora del día: " + fechaHora.TimeOfDay); 
            Console.WriteLine("Día " + fechaHora.Day);
            Console.WriteLine("Mes " + fechaHora.Month);
            Console.WriteLine("Año " + fechaHora.Year);
            Console.WriteLine("Hora " + fechaHora.Hour);
            Console.WriteLine("Minuto " + fechaHora.Minute);
            Console.WriteLine("Segundo " + fechaHora.Second);
            Console.WriteLine("Milisegundo " + fechaHora.Millisecond);
            Console.WriteLine("Ticks: " + fechaHora.Ticks);
            Console.WriteLine("Local time " + fechaHora.ToLocalTime());
            Console.WriteLine("UCT " + fechaHora.ToUniversalTime());

            Console.WriteLine("Now Local time " + DateTime.Now);
            Console.WriteLine("Now UCT " + DateTime.UtcNow);   
            
        }
        static void U1103()
        {
            Console.WriteLine("--U1103()--");
            Console.WriteLine("--Operaciones de suma y resta--");
            Console.WriteLine("-------------------------------");
            // operaciones de suma
            Console.WriteLine("Fecha base: 30 ene 2021 00:00:00");
            var fechaBase = new DateTime(2021, 01, 30);
           
            // Fecha dentro de 90 días
            var fecha90días = fechaBase.AddDays(90);
            Console.WriteLine("Suma de 90 días a la fecha base: " + fecha90días);
            // fecha dentro de 3 meses
            var fecha3meses = fechaBase.AddMonths(3);
            Console.WriteLine("Suma de 3 meses días a la fecha base: " + fecha3meses);

            // operaciones de resta
            // Fecha de hace 3 años
            var fechaHace3años = fechaBase.AddYears(-3);
            Console.WriteLine("Resta de 3 años a la fecha base: " + fechaHace3años);
            // fecha de hace  60 segundos
            var fechaHace60seg = fechaBase.AddSeconds(-60);
            Console.WriteLine("Resta de 60 segundos a la fecha base: " + fechaHace60seg);

            // Uso de Subtract para restar fechas
            var intervalo = fechaBase.Subtract(new DateTime(1970, 5, 25));
            Console.WriteLine("Subtract(): Intervalo en días:" + intervalo.TotalDays);

            // Uso de Add para sumar un intervalo de 2hs 50m 30s una fecha
            var fecha = fechaBase.Add(new TimeSpan(2, 50, 30));
            Console.WriteLine("Add(): suma de un intervalo :" + fecha);

        }
        static void U1104()
        {
            Console.WriteLine("--U1104()--");
            Console.WriteLine("--Operaciones de diferencia de fechas--");
            Console.WriteLine("---------------------------------------");
            // operaciones de suma
            var ahora = DateTime.Now;

            // Fecha dentro de 90 días
            var fecha90días = ahora.AddDays(90);

            var diferencia = fecha90días - ahora;
            Console.WriteLine("diferencia  en días: " + diferencia);

            var fecha = new DateTime(1970, 12, 30);
            int dife = ahora.Year - fecha.Year;
            Console.WriteLine("Años de diferencia (no sirve para calcular edades)" + dife);

            // cálculo de la edad exacta de una persona
            Console.WriteLine("Cálculo de edades por dos métodos diferentes");
            DateTime fechaNacimiento = new DateTime(1999, 7, 22);

            int edad = DateTime.Now.Year - fechaNacimiento.Year;
            if (fechaNacimiento.Month < DateTime.Now.Month)            
                Console.WriteLine("La edad es de {0} años", edad);
            else if (fechaNacimiento.Month > DateTime.Now.Month)            
                Console.WriteLine("La edad es de {0} años", --edad); 
            else if (fechaNacimiento.Day > DateTime.Now.Day)            
                Console.WriteLine("La edad es de {0} años", --edad);
            else
                Console.WriteLine("La edad es de {0} años", edad);

            Console.WriteLine("Método más abreviado...");
            edad = DateTime.Today.AddTicks(-fechaNacimiento.Ticks).Year - 1;
            Console.WriteLine("Otro cálculo :" + edad.ToString());
        }
        static void U1105()
        {
            Console.WriteLine("--U1105()--");
            Console.WriteLine("--Trabajo con Ticks--");
            Console.WriteLine("---------------------");
            // una fecha 
            var fechaHora = new DateTime(2021, 1, 30);     
            
            // convertir a segundos
            // desglose de los ticks
            Console.WriteLine("Desglose de la fecha 2021/1/30...");
            Console.WriteLine("Ticks:        " + fechaHora.Ticks); 
            Console.WriteLine("Milisegundos: " + fechaHora.Ticks / TimeSpan.TicksPerMillisecond);
            Console.WriteLine("Segundos:     " + fechaHora.Ticks / TimeSpan.TicksPerSecond);
            Console.WriteLine("Minutos:      " + fechaHora.Ticks / TimeSpan.TicksPerMinute);
            Console.WriteLine("Horas:        " + fechaHora.Ticks / TimeSpan.TicksPerHour);
            Console.WriteLine("Días:         " + fechaHora.Ticks / TimeSpan.TicksPerDay);  
             

            // cantidad de ticks en un año no bisiesto
            var fecha1 = new DateTime(2019, 1, 1, 0, 0, 0, 0);
            var fecha2 = new DateTime(2020, 1, 1, 0, 0, 0, 0);
            var ticks = fecha2.Ticks - fecha1.Ticks;
            Console.WriteLine("Ticks en año no bisiesto " + ticks);

            // cantidad de ticks en un año no bisiesto
            fecha1 = new DateTime(2020, 1, 1, 0, 0, 0, 0);
            fecha2 = new DateTime(2021, 1, 1, 0, 0, 0, 0);
            Console.WriteLine("Ticks en año  bisiesto " + (fecha2.Ticks - fecha1.Ticks));

            var difTicks = fecha2.Ticks - fecha1.Ticks - ticks;
            Console.WriteLine("Diferencia en ticks: " + difTicks);

            Console.WriteLine("Diferencia en días: " + difTicks / 864000000000);
        }
        
        static void U1106()
        {
            Console.WriteLine("--U1106()--");
            Console.WriteLine("--Presentación de fechas con formato específico--");
            Console.WriteLine("-------------------------------------------------");
            
            var fechaHora = new DateTime(2021, 1, 25, 16, 30, 50);
            Console.WriteLine("Fecha y hora con formato personalizado: " + fechaHora.ToString("'Fecha:' dddd',' dd-MM-yyyy '; Hora:' HH:mm:ss "));
            Console.WriteLine("Hora con formato AM/PM:  " + fechaHora.ToString("hh:mm:ss tt", CultureInfo.InvariantCulture));
            Console.WriteLine("El mes y año en distintas formas: " + fechaHora.ToString("(M-yyyy) MMM yyyy, MMMM yyyy"));

        }
        
        static void U1107() 
        {
            Console.WriteLine("--U1107()--");
            Console.WriteLine("--Creación de objetos TimeSpan--");
            Console.WriteLine("--------------------------------");
            Console.WriteLine("intervalo de 18000 días 20 h 55 m 30 s 900 ms");
            var intervalo = new TimeSpan(18000, 20, 55, 30, 900);
            Console.WriteLine("Intervalo (forma predeterminada): " + intervalo);
            Console.WriteLine("Intervalo expresado en días: " + intervalo.Days);
            Console.WriteLine("Intervalo expresado en total de días: " + intervalo.TotalDays);

            Console.WriteLine("intervalo de 5 horas 20 minutos 50 segundos");
            intervalo = new TimeSpan(5, 20, 50);
            Console.WriteLine("Intervalo (forma predeterminada): " + intervalo);
            Console.WriteLine("Intervalo expresado en horas: " + intervalo.Hours);
            Console.WriteLine("Intervalo expresado en total de horas: " + intervalo.TotalHours);

            Console.WriteLine("intervalo en ticks");
            intervalo = new TimeSpan(50000);
            Console.WriteLine("Intervalo (forma predeterminada): " + intervalo);
            Console.WriteLine("Intervalo en Ticks:" + intervalo.Ticks);

            Console.WriteLine("Utilizando el método estático FromSeconds()");
            intervalo = TimeSpan.FromSeconds(200.95);
            Console.WriteLine("Intervalo (forma predeterminada): " + intervalo);
            Console.WriteLine("Intervalo en segundos:" + intervalo.Seconds);
            Console.WriteLine("Intervalo en total de segundos:" + intervalo.TotalSeconds);

            Console.WriteLine("Utilizando el método estático FromDays()");
            intervalo = TimeSpan.FromDays(8.5);
            Console.WriteLine("Intervalo (forma predeterminada): " + intervalo);
            Console.WriteLine("Intervalo en días:" + intervalo.Days);
            Console.WriteLine("Intervalo en total de minutos:" + intervalo.TotalMinutes);
            Console.WriteLine("Intervalo en total de días:" + intervalo.TotalDays);

            // creación de TimeSpan por conversión de String
            // conversión de cadena a TimerSpan con Parse()
            Console.WriteLine("Creación de TimeSpan por conversión de String");
            Console.WriteLine("---------------------------------------------");
            Console.WriteLine("Parse()");
            var timeSpan = TimeSpan.Parse("18");
            Console.WriteLine("Hora 18: " + timeSpan);
            timeSpan = TimeSpan.Parse("30.18:30:40");
            Console.WriteLine("Día 30 y hora 18:30:40: " + timeSpan);

            // Creación de TimeSpan con método estático TryParse()
            // TryParse devuelve true si la conversión
            // se pudo hacer, caso contrario, false
            Console.WriteLine("TryParse()");
            var resultado = TimeSpan.TryParse("13:25:12", out timeSpan);
            if (resultado)
                Console.WriteLine("Conversión TryParse correcta:" + timeSpan);

            Console.WriteLine("Multiplicación del intervalo x 2 :" + timeSpan);
            timeSpan = timeSpan.Multiply(2);
            Console.WriteLine("Resultado :" + timeSpan);
        }

        
        static void U1108()
        {
            Console.WriteLine("--U1108()--");
            Console.WriteLine("--Revisión de las propiedades de TimeSpan--");
            Console.WriteLine("-------------------------------------------");

            Console.WriteLine("Fecha mínima : " + DateTime.MinValue);
            Console.WriteLine("Fecha máxima : " + DateTime.MaxValue);
            Console.WriteLine("Intervalo máximo posible");

            var intervalo = DateTime.MaxValue - DateTime.MinValue; 
            
            Console.WriteLine("Rango total en ticks: {0:E}", intervalo.Ticks);           
            Console.WriteLine("Rango total en milisegundos: {0:E}", intervalo.TotalMilliseconds);
            Console.WriteLine("Rango total en segundos: {0:E}", intervalo.TotalSeconds);
            Console.WriteLine("Rango total en minutos: {0:E}", intervalo.TotalMinutes);
            Console.WriteLine("Rango total en horas: {0:N0}", intervalo.TotalHours);
            Console.WriteLine("Rango total en días: {0:N0}", intervalo.TotalDays);
           
            Console.WriteLine("Descomposición en los componentes del intervalo: días, hs, ms, s, ms");
            Console.WriteLine("--------------------------------------------------------------------");
            Console.WriteLine("Parte del intervalo en milisegundos: " + intervalo.Milliseconds);
            Console.WriteLine("Parte del intervalo en segundos: " + intervalo.Seconds);
            Console.WriteLine("Parte del intervalo en minutos: " + intervalo.Minutes);
            Console.WriteLine("Parte del intervalo en horas: " + intervalo.Hours);
            Console.WriteLine("Parte del intervalo en días: " + intervalo.Days);

            // Constantes de TimeSpan
            Console.WriteLine("Constantes de TimeSpan");
            Console.WriteLine("----------------------");
            Console.WriteLine("Ticks por día:  {0:n0}", TimeSpan.TicksPerDay);
            Console.WriteLine("Ticks por hora: {0:n0}", TimeSpan.TicksPerHour);
            Console.WriteLine("Ticks por minuto: {0:n0}", TimeSpan.TicksPerMinute);
            Console.WriteLine("Ticks por segundo: {0:n0}", TimeSpan.TicksPerSecond);
            Console.WriteLine("Ticks por milisegundo: {0:n0}", TimeSpan.TicksPerMillisecond);
            Console.WriteLine("Campo Zero {0:n0}", TimeSpan.Zero.ToString());

        }

        
        static void U1109()
        {
            Console.WriteLine("--U1109()--");
            Console.WriteLine("--Operaciones aritméticas con objetos TimeSpan--");
            Console.WriteLine("------------------------------------------------");
            Console.WriteLine("TimeSpan es inmutable..., en una operación aritmética se crea un objeto nuevo");

            // suma, resta, multiplicación y división de tiempo a un intervalo
            // el método devuelve otro objeto TimeSpan
            var intervalo = new TimeSpan(5, 30, 45);
            Console.WriteLine("Intervalo base de los cálculos de la práctica :" + intervalo.ToString());
            Console.WriteLine("Sumar 3 horas al intervalo... " + intervalo.Add(TimeSpan.FromHours(3)));
            var tics = new TimeSpan(10000000000);
            Console.WriteLine("Restar 10.000.000.000 ticks al intervalo... " + intervalo.Subtract(tics));
            Console.WriteLine("Dividir por 2 el intervalo... " + intervalo.Divide(2));
            Console.WriteLine("Multiplicar por 6 el intervalo... " + intervalo.Multiply(6));

            // TimeSpan puede tomar valores negativos
            Console.WriteLine("Método Duration() conversión de intervalos a valor absoluto");
            intervalo = DateTime.Now - DateTime.MaxValue;
            Console.WriteLine("Resultado negativo... " + intervalo);
            // convertir en intervalo positivo
            Console.WriteLine("Conversión a valor absoluto: " + intervalo.Duration());

            
        }
    }
}
