﻿using System;
using System.IO;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections.Generic;
using System.Linq;

namespace CS_Unidad_13
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("CS_Unidad 13");
            Console.WriteLine("------------");
            //U1301();
            //U1302();
            //U1303();
            //U1304();
            //U1305();
            //U1306();
            //U1307();
            //U13080();
            U13081();
            //U1308();
            // U1309();
            //U1310();
        }
        static void U1301()
        {
            Console.WriteLine("U1301()");
            Console.WriteLine("-------");
            Console.WriteLine("FileStream: escritura de archivos");

            FileStream fs = null; 
            
            // Lista
            var listaBytes = new List<byte>();  

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado

            try
            {
                // Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                var sNom = Console.ReadLine();
                
                // Crea un flujo de bytes para el archivo texto.txt
                // modo Create: si existe lo sobrescribe
                // acceso: Write, para escritura

                fs = new FileStream(sNom, FileMode.Create, FileAccess.Write);

                // Introducción de datos desde la consola
                Console.Write("Introducir datos para el archivo {0}:", sNom);
                var cIn = Console.Read();

                // Proceso de lectura de caracteres (termina con Intro)
                while (cIn != 13)
                {
                    listaBytes.Add(Convert.ToByte(cIn));
                    cIn = Console.Read();
                }

                //  Proceso de escritura en el archivo
                fs.Write(listaBytes.ToArray(), 0, listaBytes.Count);
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                // Cerrar el flujo de datos que utiliza el archivo
                if (fs != null) {
                    Console.WriteLine("Se cierra el archivo");
                    fs.Close();
                }
            }

            Console.Read();
        }
        static void U1302()
        {
            Console.WriteLine("U1302()");
            Console.WriteLine("-------");
            Console.WriteLine("FileStream: lectura de archivos");
            FileStream fs = null;            
 
            // cantidad de bytes leídos
            int qBytes = 0;
            // Variable para el nombre del archivo  
            string sNom;
            // Variable para el contenido del archivo  
            string sDatos = "";

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado
            try
            {
                //  Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                sNom = Console.ReadLine();

                // Crea un flujo de bytes para el archivo texto.txt
                // modo Open: si no existe genera un error  
                // acceso: Read, para lectura
                fs = new FileStream(sNom, FileMode.Open, FileAccess.Read);

                // ya tenemos el bufer leído y sabemos su longitud
                // creamos la matriz receptora  
                var listaBytes = new byte[fs.Length];

                // método read lee el archivo, coloca el flujo de datos
                // en listaBytes. El parámetro con valor 0 indica el 
                // desplazamiento en el flujo de datos y el último
                // parámetro indica la cantidad máxima de bytes que se
                // pueden leer en cada acceso (la lectura real
                // queda registrada en la variable qBytes)
                qBytes = fs.Read(listaBytes, 0, (int)fs.Length);

                // La matriz la debemos convertir a cadena                
                foreach (var bytes in listaBytes)
                    sDatos += (char) bytes;

                // Impresión de datos leídos desde el archivo
                Console.Write("Contenido leído del archivo {0}: {1}", sNom, sDatos);
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                // Cerrar el flujo de datos que utiliza el archivo
                if (fs != null)
                    fs.Close();
            }

            Console.Read();
        }
        static void U1303()
        {
            Console.WriteLine("U1303()");
            Console.WriteLine("-------");
            Console.WriteLine("StreamWriter: escritura de flujo de caracteres");
            
            // el espacio de nombres System.IO se importa para poder usar la 
            // clase StreamWriter
            StreamWriter sw = null;
            // contador de registros grabados
            var iLines = 0;
            // área de entrada desde la consola
            string sIn = "";
            // indicador si append o no
            bool bAppend = false;

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado
            try
            {
                // Se obtiene el nombre del archivo de salida
                // si ya existe lo sobreescribe o lo continua
                Console.Write("Nombre del archivo: ");
                var sNom = Console.ReadLine();

                // Continuación de archivo o lo escribe 
                // desde el principio
                var mensaje = "Si continua el archivo teclear (espacio), si desde el inicio (Intro): ";
                Console.WriteLine(mensaje);

                var ck = Console.ReadKey().Key;
                while (ck != ConsoleKey.Spacebar & ck != ConsoleKey.Enter)
                { 
                    Console.WriteLine(mensaje);
                    ck = Console.ReadKey().Key;
                }
                // opción elegida
                if (ck == ConsoleKey.Spacebar)
                {
                    Console.WriteLine("Se ha elegido introducir datos al final del archivo " + sNom);
                    bAppend = true;
                }
                else
                    Console.WriteLine("Se ha elegido introducir datos al principio del archivo " + sNom);


                // Crea un flujo de caracteres para el archivo SNom   
                // acceso: desde el inicio
                // codificación: Unicode

                sw = new StreamWriter(sNom, bAppend, System.Text.Encoding.Unicode);

                // Introducción de datos desde la consola
                Console.Write(
                    "Para finalizar archivo teclear línea con sólo Intro:\n");
                sIn = Console.ReadLine();
              
                // si sólo se teclea Intro -> finaliza
                while (sIn.Length != 0)
                {
                    // contador de registros añadidos
                     iLines += 1;
                    // escribe la línea en el registro de salida
                    sw.WriteLine(sIn);                   
                    // vuelve a leer desde la consola
                    sIn = Console.ReadLine();
                }
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                // Cerrar el flujo de caracteres que utiliza el archivo
                if (sw != null)
                {
                    Console.WriteLine("Cierre de StreamWriter: se registraron  {0} líneas", iLines);
                    sw.Close();
                }
            }

            Console.Read();
        }


        static void U1304()
        {
            Console.WriteLine("U1304()");
            Console.WriteLine("-------");
            Console.WriteLine("StreamReader: lectura de flujo de caracteres");

            FileStream fb = null;
            StreamReader fc = null;

            // Variable para el nombre del archivo  
            string sNom;
            // Variable para el contenido del archivo  
            string sIn;

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado
            try {
                // Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                sNom = Console.ReadLine();

                // Crea un flujo de bytes para el archivo texto.txt
                // modo Open: si no existe genera un error  
                // acceso: Read, para lectura

                fb = new FileStream(sNom, FileMode.Open, FileAccess.Read);

                // utilizo el objeto para crear un
                // objeto StreamReader
                fc = new StreamReader(fb, System.Text.Encoding.ASCII);

                sIn = fc.ReadLine();
                while (!String.IsNullOrEmpty(sIn)) {
                    // ¿ qué leyó?
                    Console.WriteLine("Leyó.>>" + sIn);
                    sIn = fc.ReadLine();
                }
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                // Cerrar el flujo de caracteres que utiliza el archivo
                if (fc != null)
                    fc.Close();
                if (fb != null)
                    fb.Close();
            }
            Console.Read();
        }

        static void U1305()
        {
            Console.WriteLine("U1305()");
            Console.WriteLine("-------");
            Console.WriteLine("BinaryWriter: escritura de flujo de datos binarios");

            BinaryWriter fbw = null;
            FileStream fs = null;

            // Variable para el nombre del archivo  
            string sNom;

            // Variables auxiliares
            string sIn;
            int iIn;

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado
            try {
                // Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                sNom = Console.ReadLine();

                // Crea un flujo de bytes para el archivo  
                // modo Create: si existe lo sobrescribe  
                // acceso: Write, para escritura

                fs = new FileStream(sNom, FileMode.Create, FileAccess.Write);

                // utilizo el objeto para crear un
                //objeto BinaryWriter

                fbw = new BinaryWriter(fs, System.Text.Encoding.UTF8);

                Console.WriteLine("¿nombre del alumno? Fin (Intro)");
                sIn = Console.ReadLine();
                while (!String.IsNullOrEmpty(sIn)) {
                    Console.Write("Número de legajo:");
                    iIn = Convert.ToInt32(Console.ReadLine());

                    // escribe los datos en el flujo de salida 
                    fbw.Write(sIn);
                    fbw.Write(iIn);

                    // fuerza la escritura en este momento
                    fbw.Flush();
                    Console.WriteLine("Datos registrados correctamente");

                    Console.WriteLine("¿Otro nombre? Fin (Intro)");
                    sIn = Console.ReadLine();
                }
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                //  Cerrar el flujo de datos que utiliza el archivo
                if (fbw != null) fbw.Close();
                if (fs != null) fs.Close();
            }

            Console.WriteLine("Fin U1305");
        }
        static void U1306()
        {
            Console.WriteLine("U1306()");
            Console.WriteLine("-------");
            Console.WriteLine("BinaryWriter: lectura de flujo de datos binarios");

            FileStream fs = null;
            BinaryReader fbr = null;
            // Variable para el nombre del archivo  
            string sNom;
            // Variables para el contenido de los datos  
            string sIn;
            int iIn;

            // Se encierra todo en un bloque Try 
            // para gestionar los errores de modo personalizado
            try {
                // Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                sNom = Console.ReadLine();

                // Crea un flujo de bytes para el archivo texto.txt
                // modo Open: si no existe genera un error  
                // acceso: Read, para lectura

                fs = new FileStream(sNom, FileMode.Open, FileAccess.Read);

                // utilizo el objeto para crear un
                // objeto BinaryReader
                fbr = new BinaryReader(fs, System.Text.Encoding.UTF8);

                while (fbr.PeekChar() != -1)
                {
                    sIn = fbr.ReadString();
                    iIn = fbr.ReadInt32();
                    Console.WriteLine("Datos leídos: Nombre: " +
                        "{0} Número:{1}", sIn, iIn.ToString());
                }
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                // Cerrar el flujo de datos que utiliza el archivo
                if (fbr != null) fbr.Close();
                if (fs != null) fs.Close();
            }
            Console.WriteLine("Fin U1306");
        }
        static void U1307()
        {
            Console.WriteLine("U1307()");
            Console.WriteLine("-------");
            Console.WriteLine("Acceso random");

            FileStream fb = null;
            BinaryWriter fbw = null;
            BinaryReader fbr = null;

            //  la longitud física de cada registro dependerá
            //  de la codificación que utilicemos

            //  longitud de cada registro:

            //  Si la codificación es Ascii, LONGITUD SERÁ 66
            //  Las cadenas ASCii ocupan 1 byte por carácter
            //  Nombre: 1 byte longitud, 
            //  30 bytes para 30 caracteres = 31
            //  Dirección: 1 byte longitud, 
            //  30 bytes para 30 caracteres = 31 
            //  Legajo : 4 bytes
            //  Total: 66 bytes

            //  Si la codificación fuese Unicode, longitud será 126
            //  Las cadenas ocupan 2 bytes por carácter
            //  Nombre: 1 byte longitud, 
            //  60 bytes para 30 caracteres = 61
            //  Dirección: 1 byte longitud, 
            //  60 bytes para 30 caracteres = 61 
            //  Legajo : 4 bytes
            //  Total: 126 bytes

            int lReg = 126; // Si Ascii >> 66

            //  Variable  para entrada de datos
            string sDat;

            //  Variable del nombre del archivo
            string sNom;

            //  Variables auxiliares
            short ISh;
            long ILong;
            string Nombre;
            string Dirección;
            int Legajo;

            //  Se encierra todo en un bloque Try 
            //  para gestionar los errores de modo personalizado
            try
            {
                //  Se obtiene el nombre del archivo
                Console.Write("Nombre del archivo:");
                sNom = Console.ReadLine();

                //  Crea un flujo de bytes para el archivo  
                //  modo OpenOrCreate: se abre y si no existe se crea   
                //  acceso: Write, para escritura y lectura

                fb = new FileStream(sNom, FileMode.OpenOrCreate, FileAccess.ReadWrite);

                //  utilizo el objeto para crear un
                //  objeto BinaryWriter para escribir
                //  y el objeto BinaryReader para leer

                //  La codificación ASCII me asegura que todos los 
                //  códigos ocupan 1 byte
                //  Si eligiese UTF8 tendría que resolver que el flujo
                //  tendría longitud variable (una solución simple es
                //  generar un campo padding en cada registro)

                // fbw = New BinaryWriter(fb, System.Text.Encoding.ASCII)
                // fbr = New BinaryReader(fb, System.Text.Encoding.ASCII)

                fbw = new BinaryWriter(fb, System.Text.Encoding.Unicode);
                fbr = new BinaryReader(fb, System.Text.Encoding.Unicode);

                Console.WriteLine("¿Número de secuencia? Fin (Intro)");
                sDat = Console.ReadLine();

                //  el bucle se ejecuta mientras no se 
                //  introduzca Intro sin datos
                while (!String.IsNullOrEmpty(sDat)) {

                    ISh = Convert.ToInt16(sDat);
                    //  en el caso de ASCii
                    //  cada registro tiene 66 bytes (31 + 31 + 4)
                    //  por lo que el desplazamiento es ILong
                    //  número de secuencia * 66 nos dá
                    //  la posición del primer campo
                    //  del registro
                    ILong = ISh * lReg;

                    //  Si ILong se va fuera de los límites no hay datos

                    if (ILong < fbw.BaseStream.Length)
                    {
                        //  en este caso:
                        //  el posicionamiento se calcula 
                        //  desde el comienzo
                        //  se accede al registro solicitado
                        fbr.BaseStream.Seek(ILong, SeekOrigin.Begin);

                        //  Leemos los campos del registro
                        //  ¡en el orden correcto!
                        //  y con los formatos que corresponden
                        Nombre = fbr.ReadString();
                        Dirección = fbr.ReadString();
                        Legajo = fbr.ReadInt32();
                        Console.WriteLine("Datos leídos");
                    }
                    else
                    {
                        //  si no hay datos: limpio campos
                        Nombre = "";
                        Dirección = "";
                        Legajo = 0;
                        Console.WriteLine("No hay datos en esa secuencia... puede crear legajo");
                    }

                    //  Muestra los datos vigentes
                    Console.WriteLine("Nombre: {0}", Nombre);
                    Console.WriteLine("Dirección: {0}", Dirección);
                    Console.WriteLine("Legajo: {0}", Legajo);

                    //  Permite la modificación
                    //  o la inserción de nuevos campos
                    //  según sea un registro viejo o nuevo

                    //  Si el campo no cambia: pulsar Intro
                    Console.WriteLine("Teclar nuevos datos o Intro sin no hay cambios...");

                    //  Posicionamiento, pero con el flujo
                    //  de salida
                    fbw.BaseStream.Seek(ILong, SeekOrigin.Begin);

                    Console.Write("Nombre:");
                    //  Obtiene el campo Nombre
                    sDat = Console.ReadLine();
                    if (sDat.Length > 0)
                        //  ajusta la longitud: debe ser fija a 30
                        Nombre = Ajustar(sDat);
                    else
                        //  mantiene el mismo valor del campo
                        Nombre = Ajustar(Nombre);

                    //  escribe el campo
                    fbw.Write(Nombre);

                    Console.Write("Dirección:");
                    //  Obtiene la dirección
                    sDat = Console.ReadLine();
                    if (sDat.Length > 0)
                        //   ajusta la longitud: debe ser fija a 30
                        Dirección = Ajustar(sDat);
                    else
                        //  mantiene el mismo valor del campo
                        Dirección = Ajustar(Dirección);
                    //  escribe el campo Dirección 
                    fbw.Write(Dirección);

                    Console.Write("Legajo:");
                    sDat = Console.ReadLine();
                    //  Obtiene el campo Legajo
                    if (!String.IsNullOrEmpty(sDat))
                        Legajo = Convert.ToInt32(sDat);

                    //  escribe el campo Legajo
                    fbw.Write(Legajo);

                    //  fuerza la escritura en este momento
                    fbw.Flush();

                    Console.WriteLine("¿Otro registro? Informar su secuencia o para finalizar(Intro)");
                    sDat = Console.ReadLine();
                }
            }
            catch (IOException e)
            {
                Console.WriteLine("Se detecta un error IO " + e.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Se detecta un error genérico " + e.Message);
            }
            finally
            {
                //  Cerrar el flujo de datos que utiliza el archivo
                if (fbw != null) fbw.Close();
                if (fbr != null) fbr.Close();
                if (fb != null) fb.Close();
            }
            Console.Read();
        }
        static string Ajustar(string a) {
            //  ajusta la longitud del campo a 30 caracteres
            //  esta subrutina sirve para cualquier 
            //  codificación, sea ASCii o Unicode
            //  30 caracteres Unicode ocupan 60 bytes y
            //  30 caracteres ASCii ocupan 30 bytes...
            //  aquí se recortan los "caracteres" a 30
            a = a.PadRight(30);
            a = a.Substring(0, 30);
            return a;
        }
        static void U13080()
        {
            // Copia de archivos:  origen y destino (con sobrescritura)
            File.Copy("c:\\CarpetaOrigen\\HolaVBNET.vb", "c:\\CarpetaDestino\\HolaVBNET.vb", true);
            // o lo que es lo mismo
            File.Copy(@"c:\CarpetaOrigen\HolaVBNET.vb", @"c:\CarpetaDestino\HolaVBNET.vb", true);


            // Eliminar un archivo
            File.Delete(@"c:\CarpetaDestino\HolaVBNET.vb");

            // Verificar existencia antes de operar con un archivo
            if (File.Exists(@"c:\CarpetaOrigen\HolaVBNET.vb"))
            {
                var lectura = File.ReadAllText(@"c:\CarpetaOrigen\HolaVBNET.vb");
                Console.WriteLine(lectura);
            }

            // Uso de FileInfo (necesita instancia)
            var archivo = new FileInfo(@"c:\CarpetaOrigen\HolaVBNET.vb");

            // Mover el archivo a otra carpeta
            archivo.MoveTo(@"c:\CarpetaDestino\HolaVBNET.vb");

            // Borrar con FileInfo
            // obviamente, no necesita parámetros
            // como sucedía con File
            archivo.Delete(); 
            
           

        }
        static void U13081()
        {
            Console.WriteLine("U13081()");
            Console.WriteLine("-------");
            Console.WriteLine("Directory y DirectoryInfo");
            // Usos de Directory y DirectoryInfo

            // crear un directorio
            Directory.CreateDirectory(@"c:\CarpetaTemporal");

            // Verificar la existencia de un directorio
            if (Directory.Exists(@"c:\CarpetaTemporal"))
                Console.WriteLine("Directorio existe");

            // Obtener todos los archivos de un tipo determinado
            var listaExecs = Directory.GetFiles(@"c:\Windows", "*.exe", SearchOption.TopDirectoryOnly);
            // lista los ejecutables en carpeta Windows
            Console.WriteLine("Ejecutables en Windows");
            foreach (var exe in listaExecs)
                Console.WriteLine(exe);

            // lista de todos los proyectos desarrollados en C#
            Console.WriteLine("Proyectos CSharp en desarrollo");
            var miPath = @"G:\ED\source\repos\CSharp_2019";
            var listaProy = Directory.GetDirectories(miPath, "*.*", SearchOption.TopDirectoryOnly);
            foreach (var proy in listaProy)
                Console.WriteLine(proy);

            // Lo mismo que hemos hecho con Directory
            // pero ahora con DirectoryInfo

            // crear otro directorio
            // se utiliza el objeto DirectoryInfo
            DirectoryInfo di = new DirectoryInfo(@"c:\CarpetaTemporal2");
            di.Create();
            
            // Verificar la existencia de un directorio
            //¡Se usa la propiedad!!
            if (di.Exists)
                Console.WriteLine("Directorio existe");        

        }
        static void U1308()
        {
            Console.WriteLine("U1308()");
            Console.WriteLine("-------");
            Console.WriteLine("Archivos y Directorios");

            DirectoryInfo DirInfo;
            var lstDir = new List<string>();
            var lstArch = new List<string>();
            string sIn;
            string sOp;            

            //  Datos de las unidades lógicas
            //  se obtiene del objeto Directory
            foreach (var ul in Directory.GetLogicalDrives())
                Console.WriteLine("Unidades lógicas {0}", ul);

            Console.WriteLine(@"Elegir una ruta de acceso, p.ej. C:\");
            sIn = Console.ReadLine();

            while (!String.IsNullOrEmpty(sIn))
            {
                Console.WriteLine("Directorio: {0}", sIn);

                //  obtiene los subdirectorios y los archivos
                //  que hay debajo del directorio
                lstDir = obtenerSubdirectorios(sIn);
                lstArch = obtenerArchivos(sIn);

                //  lista el contenido de subdirectorios y archivos
                // dentro del directorio
                listarContenidos(lstDir, lstArch);

                //  Muestra las opciones disponibles
                Console.WriteLine("Exploración");
                Console.WriteLine("-----------\n");
                Console.WriteLine("0 = nueva ruta de acceso ");
                Console.WriteLine("P = ver directorio nivel superior ");
                Console.WriteLine("número = nro. de subdirectorio ");
                Console.WriteLine("Intro salir:");

                sOp = Console.ReadLine();
                if (!String.IsNullOrEmpty(sOp))
                {
                    if (sOp == "0")
                    {
                        //  elige una ruta de acceso cualquiera
                        Console.WriteLine("Elegir una ruta de acceso:");
                        sIn = Console.ReadLine();
                    }
                    else if (sOp == "P")
                    {
                        //  busca los datos del directorio padre 
                        DirInfo = Directory.GetParent(sIn);
                        if (DirInfo != null)
                            sIn = DirInfo.FullName;
                    }
                    else if (lstDir.Count >= Convert.ToInt16(sOp))
                    {
                        //   lista uno de los subdirectorios 
                        sIn = lstDir[Convert.ToInt16(sOp) - 1];
                    }
                    else if (lstDir.Count < Convert.ToInt16(sOp))
                    {
                        Console.WriteLine("Carpeta inexistente!!!");
                    }
                    else
                    {
                        //  cualquier valor inesperado
                        //  asume la carpeta vigente
                        sIn = Directory.GetCurrentDirectory();
                    }
                }
            }
            Console.WriteLine();
        }

        static List<string> obtenerSubdirectorios(string sIn)
        {
            // obtiene los subdirectorios dentro del
            // directorio vigente
            return Directory.GetDirectories(sIn).ToList();
        }
        static List<string> obtenerArchivos(string sIn)
        {
            // obtiene los archivos dentro del
            // directorio vigente
            return Directory.GetFiles(sIn).ToList();
        }
        static void listarContenidos(List<string> listaDir, List<string> listaArch)
        {
            // lista el contenido de 
            // las matrices de carpetas y de archivos
            short i = 0;
            Console.WriteLine("Contenido del directorio");
            Console.WriteLine("------------------------");
            Console.WriteLine("Carpetas");
            Console.WriteLine("--------");

            foreach (var dir in listaDir)
            {
                // reservamos el 0 para cambiar de ruta de acceso
                //  por eso desplazamos los índices en 1
                i += 1;
                Console.WriteLine(" carpeta {0} : {1} —> " +
                    "(Últ. acceso {2:(dd/MM)}) ", i, dir,
                    Directory.GetLastAccessTime(dir));
            }

            Console.WriteLine("Archivos");
            Console.WriteLine("--------");
            foreach (var arch in listaArch)
            {
                //  Del objeto File podemos obtener información de
                //  atributos y estado del archivo
                Console.WriteLine(" archivo {0} —> " +
                    "(Últ. acceso {1:(dd/MM)})", arch,
                    File.GetLastAccessTime(arch));
            }
        }
        static void U1309()
        {
            Console.WriteLine("U1309()");
            Console.WriteLine("-------");
            Console.WriteLine("Path: rutas de acceso");

            string curDir;
            List<String> archivos;
            
            // para simplificar tomamos el directorio vigente...

            //  obtiene el directorio vigente
            curDir = Directory.GetCurrentDirectory();

            Console.WriteLine("Directorio actual : {0}", curDir);           

            //  obtiene los archivos del directorio
            archivos = Directory.GetFiles(curDir).ToList();

            Console.WriteLine(". . . . . Datos del directorio . . . .");
            Console.WriteLine("--------------------------------------");
           
            Console.WriteLine("Raíz de la ruta de acceso: {0}", Path.GetPathRoot(curDir));

            Console.WriteLine("Ruta de acceso absoluta?: {0}", Path.IsPathRooted(curDir));
      
            Console.WriteLine("Nombre del directorio: {0}", Path.GetDirectoryName(curDir));

            Console.WriteLine("Separador de ruta de acceso: {0}", Path.PathSeparator);  
            
            Console.WriteLine(". . . archivos del directorio . . . .");
            Console.WriteLine("-------------------------------------");

            foreach (var arch in archivos)
            {
                Console.WriteLine("***");
                Console.WriteLine(Path.GetFileName(arch));                

                Console.WriteLine("Nombre del archivo: {0}", Path.GetFileName(arch));

                Console.WriteLine("Extensión del archivo: {0}", Path.GetExtension(arch));

                Console.WriteLine("Nombre del archivo sin extensión: {0}", Path.GetFileNameWithoutExtension(arch));

                Console.WriteLine("Raíz de la ruta de acceso: {0}", Path.GetPathRoot(arch));

                Console.WriteLine("Tiene extensión?: {0}", Path.HasExtension(arch));

                Console.WriteLine("Ruta de acceso absoluta?: {0}", Path.IsPathRooted(arch));
            }

            Console.WriteLine("--fin U1309()--");
        }
    }
}
  
