﻿using System;

namespace CS_Unidad_16
{


    class Program
    {
        public delegate void MyDelegate(string texto);

        public delegate void AjustesMonitorManager(Monitor monitor, int valor);

        public static void Método1(string texto)
        {
            Console.WriteLine("1:" + texto);
        }
        public static void Método2(string texto)
        {
            Console.WriteLine("2:" + texto);
        }
        public static void Método3(string texto)
        {
            Console.WriteLine("3:" + texto);
        }

        static void Main(string[] args)
        {

            Console.WriteLine("CS_Unidad 16");
            Console.WriteLine("------------");
            Console.WriteLine("Delegados y eventos");
            Console.WriteLine("-------------------");

            // Invocación de métodos con delegados 
            U1600();

            // Ejemplo práctico sin delegados 
            U1601();

            // Contraejemplo práctico con delegados 
            U1602();

            // Ejemplo de eventos
            U1603();

            // Expresiones Lambda
            U1604();
        }

        static void U1600()
        {
            Console.WriteLine("U1600()");
            Console.WriteLine("-------");
            Console.WriteLine("Invocación de métodos con delegados");

            MyDelegate delegado = Método1;
            delegado += Método3;
            delegado("Probando delegados");

            var lista = delegado.GetInvocationList();
            Console.WriteLine("Lista de invocación actual ");
            foreach (var name in lista)
            {
                Console.WriteLine(name.Method.ToString());
            }

            Console.WriteLine("Uso del delegado Action<>");
            Console.WriteLine("-------------------------");
            Action<string> delegado2 = Método1;
            delegado2 += Método3;
            delegado2("Probando delegado Action");
        }

        static void U1601()
        {
            Console.WriteLine("U1601()");
            Console.WriteLine("-------");
            Console.WriteLine("Ejemplo práctico sin delegados");

            var monitorCtrl = new MonitorControl1(23);
            monitorCtrl.Ajustes();
            monitorCtrl.Actualizar();

        }


        static void U1602()
        {
            Console.WriteLine("U1602()");
            Console.WriteLine("-------");
            Console.WriteLine("Contraejemplo práctico con delegados");

            var monitorCtrl = new MonitorControl2(25);

            // necesitamos el objeto AjustesMonitor
            // para hacer referencia a sus métodos
            var ajustes = new AjustesMonitor();

            // aquí se eligen los ajustes que se desean
            MonitorControl2.AjustesManager del = ajustes.AjustarBrillo;
            del += ajustes.AjustarVertical;
            del += MiAjusteResolución;
           
            // ejecución de la lista de métodos
            monitorCtrl.Ajustes(del);

            Console.WriteLine("Prueba de baja de suscriptor...");
            // Así se da de baja un suscriptor
            del -= MiAjusteResolución;

            // ejecución de la lista de métodos
            monitorCtrl.Ajustes(del);

            Console.WriteLine("Prueba de 2 da baja de suscriptor...");
            // Así se da de baja un suscriptor
            del -= MiAjusteResolución;

            // ejecución de la lista de métodos
            monitorCtrl.Ajustes(del);

            // se actualiza (simula) la configuración del monitor
            monitorCtrl.Actualizar();

        }

        static void MiAjusteResolución(Monitor monitor)
        {
            Console.WriteLine("Un ajuste personalizado no previsto...");
        }


        static void U1603()
        {
            Console.WriteLine("U1603()");
            Console.WriteLine("-------");
            Console.WriteLine("Ejemplo de eventos");
            var termómetro = new Termómetro();

            var ventilador = new Ventilador();
            var cortinas = new Cortinas();

            // suscriptores del evento
            termómetro.TopeAlcanzado += ventilador.OnTopeAlcanzado;
            termómetro.TopeAlcanzado += cortinas.OnTopeAlcanzado;

            termómetro.Sensor();
        }
        static void U1604()
        {
            Console.WriteLine("U1604()");
            Console.WriteLine("-------");
            Console.WriteLine("Expresiones Lambda");
            // conversión de euros a libras
            float euros = 20.50f;
            Console.WriteLine(euros + " euros = " + EuroLibras(euros) + " libras esterlinas");

            // lo mismo, con expresión Lambda

            // definición la firma del delegado
            // Func<(T1, TResult>
            Func<float, float> euroLibras;

            // asignación de la expresión Lambda al delegado
            euroLibras = euro => euro * 0.87f;

            // uso del delegado pasando un parámetro
            // y recibiendo el resultado
            Console.WriteLine(euroLibras(euros));

            Func<float, float, bool> esMayor = (float x, float y) => x > y;
            Console.WriteLine(esMayor(8f, 5f));

            Action<int, int> esMultiplo = (x, y) =>
           {
               if (x != 0 && y % x == 0)
                   Console.WriteLine("Múltiplos");
               else
                   Console.WriteLine("No múltiplos");
           };
            esMultiplo(2, 44); // true
        }
       
        static float EuroLibras(float importe)
        {
            // supongamos que alguna función
            // nos da la cotización del día
            // para este ejemplo, asumimos
            // 0,87 libras x euro
            return importe * 0.87f;
        }
    }
}
