﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CS_Unidad_16
{
    public class Termómetro
    {
        // Definición del delegado que contiene
        // la referencia a la función que se invocará
        // El primer parámetro en los eventos, de manera estandarizada,
        // suele ser el objeto que origina el evento
        // En los argumentos del evento se pueden
        // incluir datos adicionales

        //public delegate void TopeAlcanzadoEventHandler(object emisor, EventArgs args);

        // Definición del evento TopeAvanzado
        // que se basa en el delegado

        //public event TopeAlcanzadoEventHandler TopeAlcanzado;

        // equivalente a declarar delegate + event por separado
        // utilizando un delegado de .NET EventHandler
        public event EventHandler TopeAlcanzado;

        public void Sensor()
        {
            // no entramos en detalles
            // de la lógica del sensor
            // ...
            //
            Console.WriteLine("Se ha alcanzado la temperatura tope!!!");
            OnTopeAlcanzado();
        }

        protected virtual void OnTopeAlcanzado()
        {
            // Notificación a los suscriptores
            // si TopeAlcanzado no es nulo se realiza
            // la invocación 
            // si es nulo es que no hay suscriptores...
            if (TopeAlcanzado != null) 
                TopeAlcanzado(this, new EventArgs());
        }
    }
}
