﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;
using System.Xml.Linq;

namespace CS_Unidad_17
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("CS_Unidad 17");
            U1701();
            U1702();
            U1703();
            U1704();
            U1705();
            U1706();
            U1707();
            U1708();
            U1709();
            U1710();
            U1711();
            U1712();
            U1713();
            U1714();
            U1715();
        }
        static void U1701()
        {
            Console.WriteLine("U1701()");
            // Creación del origen de datos
            string[] lista = { "José", "Juana", "Cecilia", "Liliana", "Javier" };


            // Creación de la consulta
            Console.WriteLine("Sintaxis de consulta");
            var consulta1a =
                from nombre in lista
                where nombre.Substring(0, 1) == "J"
                orderby nombre 
                select nombre;

            // Ejecución de la consulta
            foreach (var nombre in consulta1a)
                Console.WriteLine("1a) Nombres {0}", nombre);

            Console.WriteLine("Sintaxis de métodos");
            var consulta1b = lista.
                Where(b => b.Substring(0, 1) == "J").
                OrderBy(b => b).
                Select(b => b); 

            // Ejecución de la consulta
            foreach (var nombre in consulta1b)
                Console.WriteLine("1b) Nombres {0}", nombre);

            // Uso de un comparador personalizado
            // que en lugar de hacer comparación alfabética
            // comprar por la longitud del texto
            var consulta1c = lista.
                Where(b => b.Substring(0, 1) == "J").
                OrderBy(b => b, new LenghtComparer()).
                Select((b,index) => new { index, b });

            // Ejecución de la consulta
            foreach (var nombre in consulta1c)
                Console.WriteLine("1c) Nombres {0}", nombre);
        }
        static void U1702()
        {
            Console.WriteLine("U1702()");
            // Consulta sin LINQ
            Console.WriteLine("Ejemplo 1");
            Console.WriteLine("--------------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            // 1) consulta tradicional sin uso de LINQ
            foreach (var producto in productos)
            {
                if (producto.BarCode <= 199)
                    Console.WriteLine("1) Una consulta tradicional sin LINQ -> Barcode {0}, Descripción {1}",
                        producto.BarCode, producto.Descripción);
            }
        }
        static void U1703()
        {
            Console.WriteLine("U1703()");
            Console.WriteLine("-------");  
             // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();  
            
            // Consulta con LINQ  
            // Métodos de extensión con LINQ
            Console.WriteLine("LINQ sintaxis de método:  Where");
            Console.WriteLine("-------------------------------");
            // Consulta con LINQ sintaxis de método
            // Where... Func<Producto, bool> es un delegado
            // por lo que podemos colocar una 
            // expresión Lambda          
            var queryProductos1 = productos.
                                  Where(p => p.BarCode <= 199);

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in queryProductos1)
                Console.WriteLine("Where) Barcode {0}, Descripción {1}",
                    producto.BarCode, producto.Descripción);

            Console.WriteLine("LINQ sintaxis de consulta: where");
            Console.WriteLine("--------------------------------");
           
            // Consulta con LINQ sintaxis de consulta        
            var queryProductos2 = from p in productos 
                                  where p.BarCode <= 199
                                  select p;

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in queryProductos2)
                Console.WriteLine("where) Barcode {0}, Descripción {1}",
                    producto.BarCode, producto.Descripción);

            Console.WriteLine("LINQ sintaxis de consulta: let");
            Console.WriteLine("------------------------------");
            // Consulta con LINQ sintaxis de consulta   
            // uso de let
            var queryProductos3 = from p in productos
                                  let gastosEnvío = p.Precio * 0.10 + 3
                                  where gastosEnvío > 15
                                  select new { BarCode = p.BarCode, Gastos = gastosEnvío };

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            Console.WriteLine("Productos con gastos de envío mayor a 15 euros");
            foreach (var producto in queryProductos3)
                Console.WriteLine("uso de let) Barcode {0}, Gastos de envío {1}",
                    producto.BarCode, producto.Gastos);
        }
        static void U1704()
        {
            Console.WriteLine("U1704()");
            Console.WriteLine("-------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            Console.WriteLine("LINQ Ejemplo - Single");
            Console.WriteLine("----------------------");

            // Búsqueda de un único resultado
            // con Single
            // DEBE  EXISTIR si no >> exception
            var descripción = productos.
               Single(p => p.BarCode == 101);

            // la respuesta es un único elemento
            Console.WriteLine("Uso de Single-> Descripción {0}",
                    descripción.Descripción);

            Console.WriteLine("LINQ Ejemplo - SingleOrDefault");
            Console.WriteLine("------------------------------");

            // Búsqueda de un único resultado
            // pero no lanza excepción si no
            // encuentra lo buscado
            descripción = productos.
               SingleOrDefault(p => p.BarCode == 999);

            // la respuesta es un único elemento
            Console.WriteLine("Uso de SingleOrDefault {0}", (descripción != null) ? descripción.Descripción : "No existe");
        }
        static void U1705()
        {
            Console.WriteLine("U1705()");
            Console.WriteLine("-------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            Console.WriteLine("LINQ Ejemplo - First");
            Console.WriteLine("----------------------");

            // Búsqueda de un único resultado
            // con First
            // DEBE  EXISTIR si no >> exception
            var descripción = productos.
                              First(p => p.BarCode > 150);

            // la respuesta es un único elemento
            Console.WriteLine("Uso de First-> Descripción {0}",
                    descripción.Descripción);             
        }

        static void U1706()
        {
            Console.WriteLine("U1706()");
            Console.WriteLine("-------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            Console.WriteLine("LINQ Ejemplo - Last");
            Console.WriteLine("----------------------");

            // Búsqueda de un único resultado
            // con Last
            // DEBE  EXISTIR si no >> exception
            var descripción = productos.
                              Last(p => p.BarCode > 150);

            // la respuesta es un único elemento
            Console.WriteLine("Uso de Last-> Descripción {0}",
                    descripción.Descripción);
        }
        static void U1707()
        {
            Console.WriteLine("U1707()");
            Console.WriteLine("-------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();
            Console.WriteLine("LINQ Ejemplo - Skip");
            Console.WriteLine("---------------------");

            // Saltar una parte de los elementos seleccionados
            // con Skip
            var descripciones = productos.
                                Where(p => p.BarCode <= 199).
                                OrderBy(p => p.Descripción).
                                Skip(2).
                                Select(p => p.Descripción);

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in descripciones)
                Console.WriteLine("Uso de Skip(2)-> Descripción {0}",
                    producto);

            Console.WriteLine("LINQ Ejemplo - Take");
            Console.WriteLine("----------------------");

            // Saltar una parte de los elementos seleccionados
            // con Skip(1) y toma sólo dos de los siguientes
            // Take(2) -  
            descripciones = productos.
                            Where(p => p.BarCode <= 199).
                            OrderBy(p => p.Descripción).
                            Skip(1).
                            Take(2).
                            Select(p => p.Descripción);

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in descripciones)
                Console.WriteLine("Uso de Skip(1).Take(2)-> Descripción {0}",
                    producto);
        }
        static void U1708() {
            Console.WriteLine("U1708()");
            Console.WriteLine("-------");
            Console.WriteLine("LINQ Ejemplo - OrderBy/OrderByDescending");
            Console.WriteLine("----------------------------------------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            // Ordenando el resultado con OrderBy   
            // OrderBy... Func<Producto, TKey> es un delegado
            // y tendremos que indicar el campo de ordenación          
            var queryProductos = productos.
                                 Where(p => p.BarCode <= 199).
                                 OrderBy(p => p.Descripción);

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in queryProductos)
                Console.WriteLine("OrderBy) Barcode {0}, Descripción {1}",
                    producto.BarCode, producto.Descripción);

            // Ordenando el resultado con OrderByDescending        
            queryProductos = productos.
                Where(p => p.BarCode <= 199).
                OrderByDescending(p => p.Descripción);

            // la respuesta es una colección filtrada
            // por lo que usamos foreach
            foreach (var producto in queryProductos)
                Console.WriteLine("OrderByDescending) Barcode {0}, Descripción {1}",
                    producto.BarCode, producto.Descripción);
        }
        static void U1709() {
            Console.WriteLine("U1709()");
            Console.WriteLine("-------");
            Console.WriteLine("LINQ Ejemplo - group ... by");
            Console.WriteLine("----------------------------------------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();


            // Agrupar por departamento
            // el departamento está definido
            // por el valor de la centena del BarCode
            var deptoAgrupado = from producto in productos
                                group producto by producto.BarCode / 100;

            Console.WriteLine("U1709"); 
            foreach(var deptoGroup in deptoAgrupado)
            {
                Console.WriteLine("Productos del departamento: " + deptoGroup.Key); 
                foreach (var prod in deptoGroup)
                {
                    Console.WriteLine("Producto {0}", prod.Descripción);
                }
            }
        }
        static void U1710()
        {
            Console.WriteLine("U1710()");
            Console.WriteLine("-------");
            Console.WriteLine("LINQ Ejemplo - group ... by... into");
            Console.WriteLine("----------------------------------------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            // Agrupar por departamento
            // el departamento está definido
            // por el valor de la centena del BarCode
            var deptoAgrupado = from producto in productos
                                group producto by producto.BarCode / 100 into deptoAux
                                where deptoAux.Count() == 2
                                select new { Departamento = deptoAux.Key, Productos = deptoAux.Count() };

            Console.WriteLine("Listado departamento con sólo 2 productos");
            foreach (var item in deptoAgrupado)
            {
                 Console.WriteLine("El departamento {0} tiene {1} productos", 
                     item.Departamento, item.Productos);
            }
        }
        static void U1711()
        {
            Console.WriteLine("U1711()");
            Console.WriteLine("-------");
            Console.WriteLine("LINQ Ejemplo - join");
            Console.WriteLine("----------------------------------------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            // creamos un segundo origen de datos
            // que se unirá al catálogo de productos
            List<ExtraDescripcion> extraDescripcion = new List<ExtraDescripcion>
            {
                new ExtraDescripcion {BarCode = 100, Fabricante = "Sony"},
                new ExtraDescripcion {BarCode = 101, Fabricante = "Acme"},
                new ExtraDescripcion {BarCode = 102, Fabricante = "Acme"},
                new ExtraDescripcion {BarCode = 103, Fabricante = "HP"},
                new ExtraDescripcion {BarCode = 104, Fabricante = "LG"},
                new ExtraDescripcion {BarCode = 200, Fabricante = "Huawei"},
                new ExtraDescripcion {BarCode = 201, Fabricante = "Fundix"},
                new ExtraDescripcion {BarCode = 300, Fabricante = "Amazon"},
                new ExtraDescripcion {BarCode = 301, Fabricante = "Inforbooks"}
            };

            // Listar productos con fabricante
            var listadoFabricante = from producto in productos
                                      join extraDesc in extraDescripcion 
                                        on producto.BarCode equals extraDesc.BarCode                               
                                      select new { Producto = producto.BarCode, 
                                                   Descripcion = producto.Descripción, 
                                                   Fabricante = extraDesc.Fabricante };

            Console.WriteLine("Listado de fabricantes de los productos");
            foreach (var item in listadoFabricante)
            {
                Console.WriteLine("Producto {0}  {1}, fabricante: {2}",
                    item.Producto, item.Descripcion, item.Fabricante);
            }
        }
        static void U1712()
        {
            Console.WriteLine("U1712()");
            Console.WriteLine("-------");
            // se obtiene el catálogo de productos
            var productos = new Catálogo().AccederCatálogo();

            Console.WriteLine("LINQ Ejemplo - Count, Sum, Average, Max, Min");
            Console.WriteLine("--------------------------------------------");

            // Obtener 
            // Count (cantidad de elementos)
            // Sum (suma de precios)
            // Average (promedio de precios)
            // Max (precio máximo)
            // Min (precio menor)

            var cantElementos = productos.Count();

            // la respuesta es un único elemento
            Console.WriteLine("Cantidad de elementos {0}", cantElementos);

            // Obtener un máximo, mínimo, promedio
            // o la suma de algún valor numérico
            var sumaPrecios = productos.Sum(p => p.Precio);

            // la respuesta es un único elemento
            Console.WriteLine("Suma de precios {0}", sumaPrecios);

            var precioPromedio = productos.Average(p => p.Precio);

            // la respuesta es un único elemento
            Console.WriteLine("Precio promedio {0}", precioPromedio);

            var productoMásCaro = productos.Max(p => p.Precio);

            // la respuesta es un único elemento
            Console.WriteLine("Producto más caro {0}", productoMásCaro);

            var productoMásBarato = productos.Min(p => p.Precio);

            // la respuesta es un único elemento
            Console.WriteLine("Producto más barato {0}", productoMásBarato);

        }  
        static void U1713()
        {
            Console.WriteLine("U1713()");
            Console.WriteLine("-------");
           

            Console.WriteLine("LINQ To XML");
            Console.WriteLine("-----------");
            try
            {
                var docXml = XDocument.Load("XMLFile1.xml");
                var alumnosSeleccionados = from lista in docXml.Descendants("alumno")
                                       where lista.Element("edad").Value == "19"
                                       select lista.Element("nombre").Value;

                Console.WriteLine("Estudiantes con 19 años");
                foreach (var elemento in alumnosSeleccionados)
                    Console.WriteLine(elemento);               
            }
            catch (Exception e)
            {
                Console.WriteLine("Error:{0}", e.Source);
                throw;
            } 
        }
        static void U1714()
        {
            Console.WriteLine("U1714()");
            Console.WriteLine("-------");


            Console.WriteLine("LINQ To XML");
            Console.WriteLine("-----------");
            try
            {
                XElement curso = new XElement("Curso", 
                               new XElement("alumno",
                                 new XElement("nombre", "Juan Carlos López"),
                                 new XElement("edad", 21),
                                 new XElement("sexo", "H")),
                               new XElement("alumno",
                                 new XElement("nombre", "Elba Gallo"),
                                 new XElement("edad", 19),
                                 new XElement("sexo", "M")),
                               new XElement("alumno",
                                 new XElement("nombre", "José González"),
                                 new XElement("edad", 19),
                                 new XElement("sexo", "H")),
                               new XElement("alumno",
                                 new XElement("nombre", "Elvira García"),
                                 new XElement("edad", 21),
                                 new XElement("sexo", "M")),
                               new XElement("alumno",
                                 new XElement("nombre", "Cecilia Rodríguez"),
                                 new XElement("edad", 21),
                                 new XElement("sexo", "M"))
                               );
            
              
                var alumnosSeleccionados = from lista in curso.Descendants("alumno")
                                           where lista.Element("edad").Value == "21" &&
                                                 lista.Element("sexo").Value == "M"
                                           select lista.Element("nombre").Value;

                Console.WriteLine("Alumnas con 21 años");
                foreach (var elemento in alumnosSeleccionados)
                    Console.WriteLine(elemento);
            }
            catch (Exception e)
            {
                Console.WriteLine("Error:{0}", e.Source);
                throw;
            }
        }
        static void U1715()
        {
            Console.WriteLine("U1715()");
            Console.WriteLine("-------");


            Console.WriteLine("LINQ To XML");
            Console.WriteLine("-----------");
            try
            {
                var docXml = XDocument.Load("XMLFile1.xml");
                var alumnosSeleccionados = new XElement("CursoAdicional",
                    from lista in docXml.Descendants("alumno")
                    select new XElement("alumno",
                                        lista.Element("nombre"),
                                        lista.Element("edad")));

                alumnosSeleccionados.Save("nuevo.xml");
            }
            catch (Exception e)
            {
                Console.WriteLine("Error:{0}", e.Source);
                throw;
            }
        }
    }

}
