﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CS_Unidad_4
{
    //**************************************************
    // Resolución de la práctica 4.1
    //************************************************** 
    class Becario : Empleado
    {
        private DateTime _fechaInicioPráctica;
        private string _centroEducativo;

        readonly string[] centros = { "Cambridge", "Oxford", "MTI" };

        public Becario()
        {
            Console.WriteLine("Constructor en Becario");
        }

        public DateTime FechaInicioPráctica
        {
            get { return _fechaInicioPráctica; }
            set { if (value < new DateTime(2019, 1, 1))
                     Informar("Error: fecha de inicio de prácticas  anterior a 1/1/2020");
                else
                    _fechaInicioPráctica = value;
            }
        }

        public string CentroEducativo
        {
            get { return _centroEducativo; }
            set
            {
                // validación básica
                bool ok = false;
                foreach (string centro in centros)
                {
                    if (centro == value)
                    {
                        ok = true;
                        // el centro educativo es correcto
                        break;
                    }
                }
                if (!ok)
                    Informar("Error: Centro educativo inválido");
                else
                    _centroEducativo = value;
            }
        }
        public override void ImprimirEmpleado()
        {
            base.ImprimirEmpleado();
            Console.WriteLine("Fecha inicio de prácticas : " + Convert.ToString(_fechaInicioPráctica));
            Console.WriteLine("Centro educativo : " + _centroEducativo);
        }

    }
}
