﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CS_Unidad_4
{
    public class Empleado
    {
        // Campos privados
        // para los nombres 
        // se recomienda el uso dePascal case

        // Para que el ejemplo del empleado oEmp5
        // funcione hay que definir  campos public para 
        // probar la nueva sintaxis del constructor
        //public string Nombre;
        //public string Sección;
        //public float Sueldo;
       

        // en realidad, deben ser todos private
        private string Nombre;
        private int NúmeroEmpleado;
        private string Dirección;
        private string Sección;
        private float Sueldo;
        

        // por defecto del modificador de acceso, esta variable es private
        // se utiliza para validar la información de Sección
        // sólo se acepta una sección que esté en esta lista
        // la hacemos readonly para evitar modificaciones por error
        readonly string[] secciones = { "Gerencia", "Contable", "Administración", "Ventas", "Almacén", "Servicio Técnico" };

          
        // Métodos públicos

        // Constructor: método que lleva el nombre de la clase
        // un constructor sin parámetros se denomina 
        // constructor por defecto
        // inicializa el objeto con los valores por defecto
        // ¿cuáles son los valores por defecto?:
        // para los campos de tipo de valor
        // el valor por defecto será cero
        // para los campos de tipo de referencia el
        // valor por defecto es null.
        public Empleado()
        {
            Console.WriteLine("Constructor en clase Empleado");
        }

        // Éste es un constructor alternativo
        // con varios parámetros
        // Esto se denomina método sobrecargado
        // puede haber más de un constructor 
        // alternativo, la condición es que
        // tenga una firma de método diferente
        // es decir, que varíen los parámetros
        // en cantidad y/o tipo de dato
        public Empleado(string nombre, int númeroEmpleado, string dirección, string sección, float sueldo)
        {
           // estando aquí dentro de la clase
           // podríamos asignar valor a los campos de esta manera
           // campo = valor;
           // pero estaríamos haciéndonos trampas a nosotros mismos
           // ya que omitiríamos la validación asociada al campo
           // obviamente también hay casos de campos que no requieren 
           // validación
           Nombre = nombre;

            // lo  correcto es pasar por los filtros de validación de cada
            // campo de datos 
            // método_de_asignación(valor)
            AsignarNombre(nombre);
            AsignarNúmeroEmpleado(númeroEmpleado);
            AsignarDirección(dirección);
            AsignarSección(sección);
            AsignarSueldo(sueldo);
        }
        
       

        // Métodos públicos
        public string LeerNombre()
        {
            return Nombre;
        }

        public void AsignarNombre(string nombre)
        {
            // validación básica
            // podríamos implementar una validación
            // más completa pero mantrenemos el ejemplo
            // simple
            if (nombre.Length == 0)
                Informar("Error: Nombre incorrecto");
            else
                Nombre = nombre;
        }
        public int LeerNúmeroEmpleado()
        {
            return NúmeroEmpleado;
        }

        public void AsignarNúmeroEmpleado(int númeroEmpleado)
        {
            // validación básica
            // se acepta un rango de valores
            if (númeroEmpleado < 1 || númeroEmpleado > 1000)
                Informar("Error: Número de empleado fuera de rango válido");
            else
                NúmeroEmpleado = númeroEmpleado;
        }
        public string LeerDirección()
        {
            return Dirección;
        }

        public void AsignarDirección(string dirección)
        {
            // validación básica
            if (dirección.Length == 0)
                Informar("Error: Faltan datos de la dirección incorrecto");
            else
                Dirección = dirección;
        }

        public string LeerSección()
        {
            return Sección;
        }

        public void AsignarSección(string sección)
        {
            // validación básica
            bool ok = false;
            foreach (string sec in secciones)
            {
                if (sec == sección)
                {
                    ok = true;
                    // si la sección existe se abandona el loop
                    break;
                }
            }
            if (!ok)
                Informar("Error: Sección incorrecta");
            else
                Sección = sección;
        }

        public float LeerSueldo()
        {
            return Sueldo;
        }

        public void AsignarSueldo(float sueldo)
        {
            // validación básica
            if (sueldo < 1000 || sueldo > 6000)
                Informar("Error: Sueldo incorrecto");
            else
                Sueldo = sueldo;
        }

       
        public virtual void ImprimirEmpleado()
        {
            // este método es público para que se pueda utilizar
            // desde una clase usuaria de esta clase
            Informar("-------------");
            Informar("Nombre:", Nombre);
            Informar("Nro. Empleado:", Convert.ToString(NúmeroEmpleado));
            Informar("Dirección:", Dirección);
            Informar("Sección:", Sección);
            Informar("Sueldo:", Convert.ToString(Sueldo));
        }

        // El método Informar está sobrecargado
        // para gestionar dos tipos de juegos de parámetros
        // pero la funcionalidad es la misma
        protected void Informar(string mensaje)
        {
            Console.WriteLine(mensaje);
        }
        protected void Informar(string dato, string mensaje)
        {
            Console.WriteLine(dato + mensaje);
        }

        
      
    }
}
