﻿using System;

namespace CS_Unidad_4
{
    class Program
    {
        static void Main(string[] args)
        {
            //**************************************************
            // Constructor sin parámetros
            //************************************************** 
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp1");
            Empleado oEmp1 = new Empleado();
            // ... los campos de datos tienen sus valores por defecto
            oEmp1.AsignarNombre("Gómez Sánchez, Paula");
            oEmp1.AsignarNúmeroEmpleado(1);
            oEmp1.AsignarDirección("Av. Francia, 18, Valencia");
            oEmp1.AsignarSección("Gerencia");
            oEmp1.AsignarSueldo(5000);
            oEmp1.ImprimirEmpleado();

            //**************************************************
            // Constructor con parámetros
            //************************************************** 
            // usamos el otro constructor
            // y usamos var en lugar de Empleado
            // es lo mismo...
            // el compilador sabe que var, en ese caso, 
            // significa tipo Empleado
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp2");
            var oEmp2 = new Empleado("Pérez, José", 2,"c/Diagonal, 8, BCN","Contable",2500);
            oEmp2.ImprimirEmpleado();

            //**************************************************
            // Comprobar las validaciones
            //************************************************** 
            // Creamos un tercer objeto con campos erróneos
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp3");
            var oEmp3 = new Empleado();          
            // número incorrecto
            oEmp3.AsignarNúmeroEmpleado(3);
            // La sección Compras es incorrecta
            oEmp3.AsignarSección("Compras");
            // Sueldo fuera de rango
            oEmp3.AsignarSueldo(15000);
            oEmp3.ImprimirEmpleado();

            //**************************************************
            // Clase derivada
            //************************************************** 
            // Creamos un objeto EmpleadoTemporal
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp4");
            var oEmp4 = new EmpleadoTemporal();
            oEmp4.AsignarNombre("Pérez, Juan");
            oEmp4.AsignarNúmeroEmpleado(4);
            oEmp4.AsignarFechaFinContrato(new DateTime(2020, 12, 1, 0, 0, 0));
            oEmp4.ImprimirEmpleado();

            //**************************************************
            // Nueva sintaxis del constructor
            //************************************************** 
            // Utilizamos otra sintaxis para el constructor
            // para este ejemplo 
            // los campos deben hacerse public
            //(algo que normalmente deberíamos evitar)
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp5");

            // hacer public los campos
            // y quitar los siguientes comentarios
            // para probar este caso

            //var oEmp5 = new Empleado 
            //  { Nombre = "González, Rafael", 
            //    Sección = "Contable",
            //    Sueldo = 2500};
            //oEmp5.AsignarNúmeroEmpleado(5);
            //oEmp5.ImprimirEmpleado();

            //**************************************************
            // Extensiones de una clase
            //************************************************** 
            // extendemos la clase int
            // para que tenga un método
            // 
            Console.WriteLine("*************");
            Console.WriteLine("Prueba de métodos de extensión");
            // ejemplo de método de extensión
            // indica si un nro. es par
            int ii = 5;
            if (ii.NúmeroPar())
                Console.WriteLine("El número {0} es Par", ii);
            else
                Console.WriteLine("El número {0} es impar", ii);

            // otro ejemplo de método de extensión
            // contador de palabras de una cadena
            string str1 = "A ver cuántas palabras hay aquí";
            Console.WriteLine("En el texto '{0}' hay {1} palabras", str1, str1.CuentaPalabras());

            str1 = "La casa rosa es de Ana";
            Console.WriteLine("Método de extensión con parámetros");
            Console.WriteLine("Aparecen {0} letras 'a' en el texto {1}", str1.CuentaUnaLetra('a'), str1);
            
            //**************************************************
            // Polimorfismo
            //************************************************** 
            Console.WriteLine("*************");
            Console.WriteLine("Prueba de polimorfismo");
            // se crea un objeto EmpleadoTemporal
            var oEmp6 = new EmpleadoTemporal();
            Console.WriteLine("empleado 6");
            oEmp6.AsignarNombre("Biondi, José");
            oEmp6.AsignarNúmeroEmpleado(6);
            oEmp6.ImprimirEmpleado();

            // los trataremos a todos como
            // si fuese de la clase Empleado
            // aunque oEmp4 y oEmp6 son 
            // de la clase EmpleadoTemporal
            Empleado[] empleados = { oEmp1, oEmp2, oEmp3, oEmp4,oEmp6 };
            foreach( Empleado x in empleados)
            {

                Console.WriteLine(x.LeerNúmeroEmpleado());

                // ImprimirEmpleado() es un método virtual
                // con override en la clase derivada
                // aunque x sea de tipo Empleado
                // cuando el objeto sea de tipo
                // EmpleadoTemporal el método
                // ImprimirEmpleado que utilizará
                // será el de EmpleadoTemporal
                // (override)
                x.ImprimirEmpleado();

            }

            //**************************************************
            // Resolución práctica 4.2 (clase Becario)
            // uso de propiedades para acceder a campos
            //************************************************** 
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp7");
            var oEmp7 = new Becario();
            // ... los campos de datos tienen sus valores por defecto
            oEmp7.AsignarNúmeroEmpleado(7);
            oEmp7.FechaInicioPráctica = new DateTime(2020, 1, 2);
            oEmp7.CentroEducativo = "Cambridge";
            oEmp7.ImprimirEmpleado();

            // ejercicio  de la práctica 4.2
            Console.WriteLine("*************");
            Console.WriteLine("Ejemplo oEmp8");
            var oEmp8 = new Becario();
            // verificamos un becario con errores
            oEmp8.AsignarNúmeroEmpleado(8);
            oEmp8.FechaInicioPráctica = new DateTime(2018, 1, 2);
            oEmp8.CentroEducativo = "Universidad de París";
            oEmp8.ImprimirEmpleado();



        }


    }

    
}
