﻿using System;
using System.Globalization;
using System.Net.NetworkInformation;

namespace CS_Unidad_8
{
    class Program
    {


        static void Main(string[] args)
        {
            // Revisión de la clase Array
            // matriz unidimensional de strings
            // no se indica el tipo, el compilador lo deduce
            string[] str = new string[] { "París", "Londres", "Lima", "Quito", "Roma" };

            // matriz unidimensional de enteros
            int[] enteros = new int[] { 2, 1, 5, 3, 6, 4, 9 };

            // matriz de dos dimensiones de tipo short
            short[,] shorts = new short[3, 2] { { 1, 5 }, { 0, 4 }, { 8, 4 } };

            // matriz escalonada de floats
            float[][] floats = new float[3][];
            floats[0] = new float[4] { 1.5f, 3.4f, 5.2f, 0f };
            floats[1] = new float[3] { 5.78f, 45.7f, 66.5f };
            floats[0] = new float[5] { 6.5f, 9.9f, 8.9f, 10.5f, 91.0f };

            // matriz escalonada de enteros con declaración y asignación
            // 
            int[][] escInts = new int[][]
             {
                   new int[] { 6, 5, 3, 2, 7, 5, 1 },
                   new int[] { 9 },
                   new int[] { 8, 6, 4 },
                   new int[] {13, 14, 43}
             };

            // matriz escalonada de enteros de dos dimensiones
            // con declaración y asignación 
            // una 3x2, otra 2x2, 4x2
            int[][,] escInts2 = new int[][,]
             {
                   new int[,] { {6, 5}, {3, 2}, {7, 5}},
                   new int[,] { {1, 9}, {5, 7} },
                   new int[,] { { 1, 3, 14, 43}, {3, 7, 11, 40} }
             };


            // ejemplo U801
            // uso de las propiedades de la clase Array
            U801();

            // ejemplo U802
            U802();

            // ejemplo U803
            U803();

            // ejemplo U804
            U804();

            // ejemplo U805
            U805();

            // ejemplo U806
            U806();

            // ejemplo U807
            U807();

            // ejemplo U808
            U808();

            // ejemplo U809
            U809();



            // ejercicio de la práctica 8.6
            Practica86();

            // ejercicio práctica 8.9
            Practica89();

        }
        static void U801()
        {
            Console.WriteLine("****U801****");
            // matriz unidimensional de strings
            // no se indica el tipo, el compilador lo deduce
            string[] strs = new string[] { "París", "Londres", "Lima", "Quito", "Roma" };

            // matriz de dos dimensiones de tipo short
            short[,] shorts = new short[3, 2] { { 1, 5 }, { 0, 4 }, { 8, 4 } };

            // propiedades de la clase Array
            // propiedad Length: indica la cantidad de elementos de todas
            // las dimensiones de la matriz.  
            Console.WriteLine("Propiedad Length");
            Console.WriteLine("Longitud del array strs " + strs.Length);
            Console.WriteLine("Longitud del array shorts " + shorts.Length);

            // Propiedad LongLength: indica la cantidad de elementos
            // en todas las dimensiones, devuelve tipo long.
            Console.WriteLine("Propiedad LongLength");
            Console.WriteLine("Total de elementos en array strs " + strs.LongLength);
            Console.WriteLine("Total de elementos en array shorts " + shorts.LongLength);

            // propiedad Rank: indica la cantidad de dimensiones
            // de la matriz; 
            Console.WriteLine("Propiedad Rank");
            Console.WriteLine("Cantidad de dimensiones del array strs " + strs.Rank);
            Console.WriteLine("Cantidad de dimensiones del array shorts " + shorts.Rank);

            // Propiedad IsFixedSize: siempre será true
            Console.WriteLine("Propiedad IsFixedSize");
            Console.WriteLine("¿Array strs es de longitud fija? " + strs.IsFixedSize);
            Console.WriteLine("¿Array shorts de longitud fija? " + shorts.IsFixedSize);

            // Propiedad IsReadOnlye:  será false
            Console.WriteLine("Propiedad IsReadOnly");
            Console.WriteLine("¿Array strs es de sólo lectura? " + strs.IsReadOnly);
            Console.WriteLine("¿Array shorts es de sólo lectura? " + shorts.IsReadOnly);

            Console.WriteLine("----fin U801----");
        }


        static void U802()
        {
            // Ejemplo de uso de métodos de la clase Array
            Console.WriteLine("****U802****");

            Console.WriteLine("Matriz de 1 dimensión");
            int[] ints1D = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };

            Console.WriteLine("Cantidad de dimensiones. Rank: " + ints1D.Rank);
            Console.WriteLine("Matriz 1D original");
            // listar contenido de la matriz
            for (int i = 0; i < ints1D.Length; i++)
                 Console.WriteLine("Elem.[{0}] = valor {1} ", i, ints1D[i]);
           
            Console.WriteLine();

            // el método Clear borra el elemento colocando
            // el valor predeterminado del tipo, en este caso,
            // coloca ceros
            // desde el índice 7, 3 elementos (7, 8 y 9) 
            Console.WriteLine("Array.Clear(intss1D, 7, 3)");
            Array.Clear(ints1D, 7, 3);
         
            Console.WriteLine("Matriz 1D después del borrado");
            // listar contenido de la matriz
            for (int i = 0; i < ints1D.Length; i++)
                 Console.WriteLine("Elem.[{0}] = valor {1} ", i, ints1D[i]);
            Console.WriteLine("---------------");


            Console.WriteLine("Matriz de 2 dimensiones");
            // matriz de 4 x 3
            int[,] ints2D = { { 0, 1, 2 }, { 3, 4, 5 }, { 6, 7, 8 }, { 9, 10, 11 } };

            Console.WriteLine("Cantidad de dimensiones. Rank: " + ints2D.Rank);

            // Con el método GetLength se puede saber
            // la cantidad de elementos de cada dimensión
            // individualmente
            Console.WriteLine("Matriz 2D original");
            for (int i = 0; i < ints2D.GetLength(0); i++)
            {
                for (int j = 0; j < ints2D.GetLength(1); j++)
                    Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, ints2D[i, j]);
                Console.WriteLine();
            }

            Console.WriteLine();
            // borrado parcial de una matriz 2D
            Console.WriteLine("Array.Clear(ints2D, 7, 3)");
            Array.Clear(ints2D, 7, 3);
            Console.WriteLine("Matriz 2D después del borrado");
            for (int i = 0; i < ints2D.GetLength(0); i++)
            {
                for (int j = 0; j < ints2D.GetLength(1); j++)
                    Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, ints2D[i, j]);
                Console.WriteLine();
            }
            Console.WriteLine("---------------");

            Console.WriteLine("Matriz de 3 dimensiones");
            Console.WriteLine("Distintas maneras de declarar la matriz 3D");
            // define una matriz de 3 x 2 x 2

            // podríamos declarar y asignar de esta manera
            // método más compacto
            //var ints3D = new int[,,] {{{0, 1}, {2, 3}},
            //                          {{4, 5}, {6, 7}},
            //                          {{8, 9}, {10, 11}}};

            // o podríamos declarar y asignar de esta 
            // otra manera
            //int[,,] ints3D = {{{0, 1}, {2, 3}},
            //                  {{4, 5}, {6, 7}},
            //                  {{8, 9}, {10, 11}}};

            // si se prefiere otro método
            // esta declaración con
            // asignación posterior
            // esto es equivalente a las anteriores
            var ints3D = new int[3, 2, 2];
            ints3D[0, 0, 0] = 0;
            ints3D[0, 0, 1] = 1;
            ints3D[0, 1, 0] = 2;
            ints3D[0, 1, 1] = 3;
            ints3D[1, 0, 0] = 4;
            ints3D[1, 0, 1] = 5;
            ints3D[1, 1, 0] = 6;
            ints3D[1, 1, 1] = 7;
            ints3D[2, 0, 0] = 8;
            ints3D[2, 0, 1] = 9;
            ints3D[2, 1, 0] = 10;
            ints3D[2, 1, 1] = 11;
            Console.WriteLine("Cantidad de dimensiones. Rank: " + ints3D.Rank);

            Console.WriteLine("Matriz 3D original");

            // Usamos foreach para listar la matriz
            Console.WriteLine("Listar con foreach matriz 3D");
            foreach (var i in ints3D)
                Console.Write("  " + i);

            Console.WriteLine(" ");

            Console.WriteLine("Listar con bucles for anidados");
            for (int i = 0; i < ints3D.GetLength(0); i++)
            {
                for (int j = 0; j < ints3D.GetLength(1); j++)
                   for (int k = 0; k < ints3D.GetLength(2); k++)
                       Console.WriteLine("Elem.[{0}] [{1}] [{2}] = valor {3} ", i, j, k, ints3D[i, j, k]);               
            }

            Console.WriteLine("---------");

            Console.WriteLine("Matriz 3D borrado parcial");
            Console.WriteLine("Array.Clear(ints3D, 7, 3)");
            Array.Clear(ints3D, 7, 3);

            Console.WriteLine("Matriz 3D después del borrado");
            for (int i = 0; i < ints3D.GetLength(0); i++)
            {
                for (int j = 0; j < ints3D.GetLength(1); j++)
                   for (int k = 0; k < ints3D.GetLength(2); k++)
                        Console.WriteLine("Elem.[{0}] [{1}] [{2}] = valor {3} ", i, j, k, ints3D[i, j, k]);
             }

            Console.WriteLine("Matriz de matrices (matriz dentada)");
            // matriz  [3][]
            // ésta es una matriz que contiene tres matrices
            // las matrices contenidas pueden tener 
            // longitud diferente pero deben ser
            // de la misma dimensión y contener el
            // mismo tipo de dato
            int[][] dentada1 = {
                                 new int[] { 0, 1, 2, 3, 4, 5 },
                                 new int[] { 6, 7 },
                                 new int[] { 8, 9, 10, 11}
                                };

            // el Rank es el mismo en todas las matrices
            Console.WriteLine("Cantidad de dimensiones. Rank: " + dentada1[0].Rank);
            Console.WriteLine("Cantidad de dimensiones. Rank: " + dentada1[1].Rank);
            Console.WriteLine("Cantidad de dimensiones. Rank: " + dentada1[2].Rank);

            // Usamos foreach para listar la matriz
            Console.WriteLine("Listar con foreach matriz dentada");

            for (int i = 0; i < dentada1.Length; i++)
                 foreach (var j in dentada1[i])
                    Console.WriteLine("Matriz [{0}], valor {1}  ", i, j);

            Console.WriteLine(" ");

            // Con el método Length aplicado a cada una de las matrices
            // se obtiene la cantidad de elementos de cada una
            Console.WriteLine("Matriz dentada original");
            for (int i = 0; i < dentada1.Length; i++)
            {
                for (int j = 0; j < dentada1[i].Length; j++)
                    Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, dentada1[i][j]);
                Console.WriteLine();
            }

            Console.WriteLine();

            // borrado parcial de una matriz dentada
            Console.WriteLine("Array.Clear(dentada1[0], 3, 3)");
            Console.WriteLine("Array.Clear(dentada1[1], 1, 1)");
            Console.WriteLine("Array.Clear(dentada1[2], 0, 2)");
            Array.Clear(dentada1[0], 3, 3);
            Array.Clear(dentada1[1], 1, 1);
            Array.Clear(dentada1[2], 0, 2);

            Console.WriteLine("Matriz dentada después del borrado parcial");
            for (int i = 0; i < dentada1.Length; i++)
            {
                for (int j = 0; j < dentada1[i].Length; j++)
                    Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, dentada1[i][j]);
                Console.WriteLine();
            }

            // borrado completo de una matriz dentada          
            for (int i = 0; i < dentada1.Length; i++)
                Array.Clear(dentada1[i], 0, dentada1[i].Length);

            Console.WriteLine("Matriz dentada después del borrado completo");
            for (int i = 0; i < dentada1.Length; i++)
            {
                for (int j = 0; j < dentada1[i].Length; j++)
                    Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, dentada1[i][j]);  
                Console.WriteLine();
             };

            Console.WriteLine("--fin U802()--");

        }

        static void U803()
        {
            // Ejemplo de uso de métodos de la clase Array
            Console.WriteLine("****U803****");
            // matrices utilizadas en los ejemplos

            // matriz unidimensional de enteros
            int[] enteros1D = new int[] { 111, 102, 113, 104, 115, 106, 117 , 108, 119, 110, 121, 112};
             
            // matriz bidimensional de enteros (2 x 3)
            int[,] enteros2D = new int[,] {{1, 2}, { 3, 4 }, { 5, 6 }};

            // matriz unidimensional de cadenas
            string[] cadenas = new string[] { "París", "Londres", "New York" };

            // matriz dentada
            int[][] dentada1 = {
                                 new int[] { 0, 1, 2, 3, 4, 5 },
                                 new int[] { 6, 7 },
                                 new int[] { 8, 9, 10, 11}
                                };

            // matriz de objetos de la clase Persona
            Persona[] personas = new Persona[2];
            personas[0] = new Persona("José");
            personas[1] = new Persona("Juana");

            Console.WriteLine("Matriz original con la que trabajaremos");
            foreach (var i in enteros1D)
                Console.Write(i + " ");
            Console.WriteLine("----------");

            // Método IndexOf()
            // Nos devuelve el valor del índice de
            // un determinado elemento de la matriz
            // en caso de que haya más de un elemento
            // con ese valor
            // nos informa la primera aparición
            var num = Array.IndexOf(enteros1D, 119);
            Console.WriteLine("IndexOf(): obtener el valor del índice");
            Console.WriteLine("El valor 119 está en el índice " + num);
            Console.WriteLine("-----------");


            // Método Copy()
            // Para copiar se debe haber declarado la matriz de destino
            Console.WriteLine("Copy(): Copia de matriz a matriz");
            Object[,] destino2D = new Object[2,3];
            Array.Copy(enteros2D, 2, destino2D, 1, 4);
            
            // Veamos qué copió
            foreach(var i in destino2D)
                Console.WriteLine(i);
            Console.WriteLine("---------");


            // Método CopyTo()
            // Para copiar matriz unidimensional
            Console.WriteLine("CopyTo(): Copia de matriz unidimensional");
            Object[] destino1D = new Object[3];
            Array.Copy(enteros1D, destino1D, 3);

            // Veamos qué copió
            foreach (var i in destino1D)
                Console.WriteLine(i);
            Console.WriteLine("---------");


            // Método Clone()
            // realiza un copia superficial de una matriz
            // (serán dos variables con igual referencia)
            Console.WriteLine("Clonado(): Copia superficial de matrices");
            int[]     clonEnteros = (int[]) enteros1D.Clone();
            string[]  clonCadenas = (string[])cadenas.Clone();
            int[][]   clonDentada = (int[][])dentada1.Clone();
            Persona[] clonPersonas = (Persona[])personas.Clone();

            // Clonación de matriz de enteros: veamos sus referencias
            Console.WriteLine("ReferenceEquals matriz de enteros" );
            var result = (Object.ReferenceEquals(enteros1D[0], clonEnteros[0])) ? "iguales" : "diferentes";
            Console.WriteLine("las  referencias son " + result);
            // modificamos un elemento de una de las matrices
            enteros1D[0] = 1000;

            // no hacen referencia a la misma memoria
            Console.WriteLine("enteros [0] = {0}", enteros1D[0]);
            Console.WriteLine("clonEnteros [0] = {0}", clonEnteros[0]);
            Console.WriteLine("---------");

            // Clonación de matriz de strings: veamos sus referencias
            Console.WriteLine("ReferenceEquals strings");
            result = (Object.ReferenceEquals(cadenas[0], clonCadenas[0])) ? "iguales" : "diferentes";
            Console.WriteLine("las  referencias son " + result);
            // modificamos un elemento de una de las matrices
            cadenas[0] = "Boston";

            // no hacen referencia a la misma memoria
            Console.WriteLine("cadenas [0] = {0}", cadenas[0]);
            Console.WriteLine("clonCadenas [0] = {0}", clonCadenas[0]);
            Console.WriteLine("---------");

            // Clonación de dentadas: Veamos sus referencias
            Console.WriteLine("ReferenceEquals matriz de matrices");
            result = (ReferenceEquals(dentada1[0], clonDentada[0])) ? "iguales" : "diferentes";
            Console.WriteLine("las  referencias son " + result);
            // modificamos un elemento de una de las matrices
            dentada1[0][0] = 999;

            // hacen referencia a la misma memoria
            Console.WriteLine("dentada1 [0][0] = {0}", dentada1[0][0]);
            Console.WriteLine("clonDentada [0][0]= {0}", clonDentada[0][0]);
            Console.WriteLine("---------");

            // Clonación de clase Persona: veamos sus referencias
            Console.WriteLine("ReferenceEquals objetos de una clase");
            result = (ReferenceEquals(personas[0], clonPersonas[0])) ? "iguales" : "diferentes";
            Console.WriteLine("las  referencias son " + result);
            // modificamos un elemento de una de las matrices
            personas[0].name = "Candela";

            // hacen referencia a la misma memoria
            Console.WriteLine("personas[0] = {0}", personas[0].name);
            Console.WriteLine("clonPersonas[0]= {0}", clonPersonas[0].name);
            Console.WriteLine("---------");

            // Método Sort()
            // para ordenar una matriz
            // el método tiene 17 sobrecargas...
            // que son variaciones del método
            // en este caso ordenaremos parcialmente
            // la matriz, desde el índice 4 hasta el 8
            Array.Sort(enteros1D, 4, 5);
            // Veamos cómo ordenó 
            foreach (var i in enteros1D)
                Console.Write(i + " ");
            Console.WriteLine("---------");

            // Método Reverse()
            // para revertir una matriz 
            // tiene 4 sobrecargas
            // por ejemplo, se puede hacer una
            // reversión total o parcial
            // haremos una parcial de los
            // tres primeros elementos
            Array.Reverse(enteros1D, 0, 3);
            // Veamos cómo revirtió
            foreach (var i in enteros1D)
                Console.Write(i + " ");
            Console.WriteLine("---------");

            Console.WriteLine("----fin U803----");            

        }
       
        static void Practica86()
        {
            // matriz cuadrada
            int[,] miArray = new int[5, 5]
            {
                { 11, 51, 12, 38, 55},
                { 30, 16, 73, 21, 31},
                { 75, 15, 22, 78, 90},
                { 49, 64, 72, 21, 12},
                { 94, 85, 54, 39, 22}
            };


            // Lista matriz original
            Console.WriteLine("Matriz original");
            foreach (int elemento in miArray)
            {
                Console.WriteLine(elemento);
            }

            // invertir matriz 
            // cambia fila x columna
            var aux = 0;
            for (var i = 0; i < miArray.GetLength(0); i++)
            {
                for (var j = i; j < miArray.GetLength(1); j++)
                {
                    // invierte fila columna
                    aux = miArray[i, j];
                    miArray[i, j] = miArray[j, i];
                    miArray[j, i] = aux;
                }
            }

            // Lista matriz invertida
            Console.WriteLine("Matriz invertida");
            foreach (int elemento in miArray)
            {
                Console.WriteLine(elemento);
            }
        }
        static void Practica89()
        {
            // matriz 1
            int[,] miArray1 = new int[2, 5]
            {
                { 49, 64, 72, 21, 12},
                { 94, 85, 54, 39, 22}
            };
            // matriz 2
            int[,] miArray2 = new int[2, 5]
            {
                { 49, 64, 72, 21, 12},
                { 94, 85, 54, 39, 22}
            };

            // ¿Son iguales estas matrices?
            bool test = (Array.Equals(miArray1, miArray2)) ? true : false;
            Console.WriteLine(test);

        }
        public class Persona
        {
            public string name;

            public Persona(string name)
            {
                this.name = name;
            }

        }
    }
}
