﻿using System;

class Example
{
    public static void Main()
    {
        Console.WriteLine("Matriz de 1 dimensión");
        int[] ints1D = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
        Console.WriteLine("Cantidad de dimensiones. Rank: " + ints1D.Rank);
        Console.WriteLine("Matriz 1D original");
        // listar contenido de la matriz
        for (int i = 0; i < ints1D.Length; i++)
        {
            Console.WriteLine("Elem.[{0}] = valor {1} ", i, ints1D[i]);
        }
        Console.WriteLine();

        // el método Clear borra el elemento colocando
        // el valor predeterminado del tipo, en este caso,
        // coloca ceros
        // desde el índice 7, 3 elementos (7, 8 y 9) 
        Console.WriteLine("Array.Clear(intss1D, 7, 3)");
        Array.Clear(ints1D, 7, 3);

        Console.WriteLine("Matriz 1D después del borrado");
        // listar contenido de la matriz
        for (int i = 0; i < ints1D.Length; i++)
        {
            Console.WriteLine("Elem.[{0}] = valor {1} ", i, ints1D[i]);
        }
        Console.WriteLine("---------------");


        Console.WriteLine("Matriz de 2 dimensiones");
        // matriz de 4 x 3
        int[,] ints2D = { { 0, 1, 2 }, { 3, 4, 5 }, { 6, 7, 8 }, { 9, 10, 11 } };
        Console.WriteLine("Cantidad de dimensiones. Rank: " + ints2D.Rank);
        // Con el método GetLength se puede saber
        // la cantidad de elementos de cada dimensión
        // individualmente
        Console.WriteLine("Matriz 2D original");
        for (int i = 0; i < ints2D.GetLength(0); i++)
        {
            for (int j = 0; j < ints2D.GetLength(1); j++)
            {
                Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, ints2D[i, j]);
            }
            Console.WriteLine();
        }

        Console.WriteLine();
        // borrado parcial de una matriz 2D
        Console.WriteLine("Array.Clear(ints2D, 7, 3)");
        Array.Clear(ints2D, 7, 3);
        Console.WriteLine("Matriz 2D después del borrado");
        for (int i = 0; i < ints2D.GetLength(0); i++)
        {
            for (int j = 0; j < ints2D.GetLength(1); j++)
            {
                Console.WriteLine("Elem.[{0}] [{1}] = valor {2} ", i, j, ints2D[i, j]);
            }
            Console.WriteLine();
        }
        Console.WriteLine("---------------");

        Console.WriteLine("Matriz de 3 dimensiones");
        Console.WriteLine("Distintas maneras de declarar la matriz 3D");
        // define una matriz de 3 x 2 x 2

        // podríamos declarar y asignar de esta manera
        //var ints3D = new int[,,] {{{0, 1}, {2, 3}},
        //                          {{4, 5}, {6, 7}},
        //                          {{8, 9}, {10, 11}}};

        // o podríamos declarar y asignar de esta 
        // otra manera
        //int[,,] ints3D = {{{0, 1}, {2, 3}},
        //                  {{4, 5}, {6, 7}},
        //                  {{8, 9}, {10, 11}}};

        // si se prefiere otro método
        // esta declaración con
        // asignación posterior
        // esto es equivalente a las anteriores
        var ints3D = new int[3, 2, 2];
        ints3D[0, 0, 0] = 0;
        ints3D[0, 0, 1] = 1;
        ints3D[0, 1, 0] = 2;
        ints3D[0, 1, 1] = 3;
        ints3D[1, 0, 0] = 4;
        ints3D[1, 0, 1] = 5;
        ints3D[1, 1, 0] = 6;
        ints3D[1, 1, 1] = 7;
        ints3D[2, 0, 0] = 8;
        ints3D[2, 0, 1] = 9;
        ints3D[2, 1, 0] = 10;
        ints3D[2, 1, 1] = 11;
        Console.WriteLine("Cantidad de dimensiones. Rank: " + ints3D.Rank);

        Console.WriteLine("Matriz 3D original");
        // Usamos foreach para listar la matriz
        Console.WriteLine("Listar con foreach matriz 3D");
        foreach (var i in ints3D)
            Console.Write("  " + i);
        Console.WriteLine(" ");
        Console.WriteLine("Listar con bucles for anidados");
        for (int i = 0; i < ints3D.GetLength(0); i++)
        {
            for (int j = 0; j < ints3D.GetLength(1); j++)
            {
                for (int k = 0; k < ints3D.GetLength(2); k++)
                {
                    Console.WriteLine("Elem.[{0}] [{1}] [{2}] = valor {3} ", i, j, k, ints3D[i, j, k]);
                }
            }
        }
        Console.WriteLine("---------");
        Console.WriteLine("Matriz 3D borrado parcial");
        Console.WriteLine("Array.Clear(ints3D, 7, 3)");
        Array.Clear(ints3D, 7, 3);
        Console.WriteLine("Matriz 3D después del borrado");
        for (int i = 0; i < ints3D.GetLength(0); i++)
        {
            for (int j = 0; j < ints3D.GetLength(1); j++)
            {
                for (int k = 0; k < ints3D.GetLength(2); k++)
                {
                    Console.WriteLine("Elem.[{0}] [{1}] [{2}] = valor {3} ", i, j, k, ints3D[i, j, k]);
                }
            }
        }
    }
}
