﻿using System;
using System.Globalization;
using System.Text;

namespace CS_Unidad_9
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Unidad 9");
            Console.WriteLine("********");

            // U901()Práctica de modos de concatenación de cadenas
            U901();

            // U902(): Validación de cadenas
            U902();

            // U903() Recortes y padding de cadenas
            U903();

            // U904() Conversiones
            U904();

            // U905() Búsquedas y reemplazos
            U905();

            // U906() Caracteres de escape y @
            U906();

            // U907() StringBuilder: asignación de contenido
            U907();

            // U908() StringBuilder: manipulaciones 
            // inserciones, reemplazos y eliminaciones
            U908();

            // U909() StringBuilder: superando la capacidad máxima
            U909();
            
        }

        static void U901()
        {
            Console.WriteLine("Ejemplo U901");
            Console.WriteLine("------------");
            Console.WriteLine("Formas de concatenación de cadenas");

            // formas de concatenación de cadenas

            var lenguaje = "C#";
            var ide = "Visual Studio 2019";

            // concatenando con operador + 
            Console.WriteLine("\nConcatenando con +");
            Console.WriteLine("Curso de " + lenguaje + " con el IDE de " + ide);

            // concatenando con método Concat
            Console.WriteLine("\nConcatenando con Concat");
            Console.WriteLine(String.Concat("Curso de ", lenguaje, " con el IDE de ", ide));

            // Concatenando con método Format
            Console.WriteLine("\nConcatenando con Format");
            Console.WriteLine(String.Format("Curso de {0} con el IDE de {1}", lenguaje, ide));

            // Concatenando con Join
            Console.WriteLine("\nConcatenando con Join");
            var alumnos = new string[4] { "carlos", "julia", "silvia", "Arturo" };
            Console.WriteLine("Uso de ToUpper para cambiar a mayúsculas");
            // Usamos el método ToUpper para asegurarnos que la 
            // primera letra de cada nombre va en mayúsculas
            for (int i = 0; i < alumnos.Length; i++)
            {
                alumnos[i] = alumnos[i].Substring(0, 1).ToUpper() + alumnos[i].Substring(1);
            }

            Console.WriteLine("Comprobamos corrección con ToUpper");
            foreach(var alumno in alumnos)
                Console.WriteLine(alumno);

            // Concatenando los elementos en un único String
            var listaCSV = String.Join(", ", alumnos);
            Console.WriteLine("Resultado Join");
            Console.WriteLine("Alumnos ." + listaCSV);

            // Split, la operación inversa a Join
            // separar una cadena en diferentes subelementos
            Console.WriteLine("\nTroceando con Split");
            String[] matrizAlumnos = listaCSV.Split(", ");
            Console.WriteLine("Resultado Split");
            foreach (var nombre in matrizAlumnos)
                Console.WriteLine("Nombre: {0}", nombre);
  
            Console.WriteLine("--fin ejemplo--");
        }

        static void U902()
        {
            Console.WriteLine("Ejemplo U902");
            Console.WriteLine("------------");
            Console.WriteLine("Validaciones");
            Console.WriteLine("------------");
            // Métodos para validaciones
            // IsNullOrEmpty(), IsNullOrWhiteSpace  

            String miStrVacio = new String("");

            Console.WriteLine("1. Validando si nulo o vacío");
            if (String.IsNullOrEmpty(miStrVacio))
                Console.WriteLine("Soy null o vacío...");

            Console.WriteLine("2. Validando si nulo o espacio en blanco");
            if (String.IsNullOrWhiteSpace(miStrVacio))
            {
                Console.WriteLine("{0} soy null o espacio en blanco", miStrVacio);
            }
            else
            {
                Console.WriteLine("{0} no soy null ni espacio en blanco", miStrVacio);
            }


            Console.WriteLine("3. Validando si nulo o espacio en blanco");
            if (String.IsNullOrWhiteSpace("String con datos"))
            {
                Console.WriteLine("Soy null o espacio en blanco");
            }
            else
            {
                Console.WriteLine("No soy ni null ni espacio en blanco");
            }

            // método Equals, igualdad entre cadenas
            // respuesta: true/false
            if (String.Equals(miStrVacio, String.Empty))
                Console.WriteLine("4. Uso de Equals...soy una cadena vacía");


            // Igualdad de contenido
            Console.WriteLine("5. Uso del método Compare");
            var str1 = "test1";
            var str2 = "TEST1";

            if (String.Compare(str1, str2) < 0)
                Console.WriteLine("str1 {0} es menor que str2 {1}", str1, str2);
            if (String.Compare(str1, str2) == 0)
                Console.WriteLine("str1 y str2 son Iguales");
            if (String.Compare(str1, str2) > 0)
                Console.WriteLine("str1 {0} es mayor que str2 {1}", str1, str2);

            // igualamos los contenidos
            // con ToLower()
            Console.WriteLine("Igualamos contenido con ToLower()");
            str2 = str2.ToLower();
            if (String.Compare(str1, str2) < 0)
                Console.WriteLine("str1 {0} es menor que str2 {1}", str1, str2);
            if (String.Compare(str1, str2) == 0)
                Console.WriteLine("str1 y str2 son Iguales");
            if (String.Compare(str1, str2) > 0)
                Console.WriteLine("str1 {0} es mayor que str2 {1}", str1, str2);

            Console.WriteLine("--fin ejemplo--");
        }

        static void U903()
        {
            Console.WriteLine("Ejemplo U903");
            Console.WriteLine("------------");
            Console.WriteLine("Recortes y padding de cadenas");
            Console.WriteLine("-----------------------------");

            // Trim(): quitando cosas del principio y del final
            
            char[] arrayVocales = { 'a', 'e', 'i', 'o', 'u' };

            Console.WriteLine("Prácticas con Trim()");
            // quita espacios del inicio y del final
            Console.WriteLine("Trim de espacios en la cadena:    a la casa roja ");
            Console.WriteLine("Resultado:" + "   la casa roja    ".Trim());
            // quita un carácter determinado del inicio y del final
            Console.WriteLine("Trim de letra a en la cadena: a la casa roja");
            Console.WriteLine("Resultado:" + "a la casa roja".Trim('a'));
            // quita cualquiera de los caracteres de un array
            // del inicio y final de la cadena
            // quitaremos las vocales... siempre que estén al principio o al final
            Console.WriteLine("Trim de las vocales en la cadena: aaeeuia * Título * uia");
            Console.WriteLine("Resultado: " + "aaeeuia*Título*uia".Trim(arrayVocales));

            Console.WriteLine("Prácticas con TrimEnd()");
            // TrimEnd quita cosas sólo del final

            // quita espacios del final
            Console.WriteLine("TrimEnd de espacios:la casa roja    ");
            Console.WriteLine("Resultado:" + "la casa roja    ".TrimEnd());
            // quita un carácter determinado del final
            Console.WriteLine("TrimEnd de carácter a:a la casa roja");
            Console.WriteLine("Resultado:" + "a la casa roja".TrimEnd('a'));
            // quita cualquiera de los caracteres de un array
            // del final de la cadena
            Console.WriteLine("TrimEnd de array de vocales de la cadena:aaeeuia * Título * uia");
            Console.WriteLine("Resultado:" + "aaeeuia*Título*uia".TrimEnd(arrayVocales));

            Console.WriteLine("Prácticas con TrimStart()");
            // TrimStart quita cosas sólo del principio

            Console.WriteLine("TrimStart de espacios iniciales:    la casa roja    ");
            Console.WriteLine("Resultado:" + "    la casa roja    ".TrimStart());
            // quita un carácter determinado del inicio
            Console.WriteLine("TrimStart de carácter a:a la casa roja");
            Console.WriteLine("Resultado:" + "a la casa roja".TrimStart('a'));
            // quita cualquiera de los caracteres de un array
            // del inicio de la cadena
            Console.WriteLine("TrimStart de array de vocales de la cadena:aaeeuia * Título * uia");
            Console.WriteLine("Resultado:" + "aaeeuia*Título*uia".TrimStart(arrayVocales));

            Console.WriteLine("Prácticas con Paddings");
            // Padding: rellenando por izquierda o por derecha
            var str = "Hola";
            // La cadena Hola tiene 4 caracteres
            // con PadLeft se eleva a 10 caracteres xxxxxxHola
            // rellenando con x a la izquierda
            // con PadRight se eleva a 15 caracteres xxxxxxHola*****
            // rellenando con * por la derecha
            Console.WriteLine(str.PadLeft(10, 'x').PadRight(15, '*'));


            Console.WriteLine("--fin ejemplo--");
        }

        static void U904()
        {
            Console.WriteLine("Ejemplo U904");
            Console.WriteLine("------------");
            Console.WriteLine("Conversiones");
            Console.WriteLine("------------"); 
            // Opciones de conversiones

            // Convert
            // no está limitada a conversiones de cadena
            // a número...
            // convierte cualquier clase a otra que
            // que implemente IConvertible
            // en el caso, de cadenas a números...
            // si rango correcto, convierte a entero
            // si valor nulo, devuelve  0
            // si el formato incorrecto: FormatException
            // si rango incorrecto: OverflowException

            // Parse
            // convierte de cadena a número
            // si rango correcto, convierte a número
            // si valor nulo: ArgumentNullException
            // si el formato incorrecto: FormatException
            // si rango incorrecto: OverflowException

            // TryParse
            // convierte de cadena a número
            // si rango correcto, convierte a entero, devuelve true
            // si valor nulo: convierte a 0, devuelve false
            // si el formato incorrecto: convierte a 0, devuelve false
            // si rango incorrecto: convierte a 0, devuelve false

            // Conversiones
            // de string a tipo numérico
            // valor negativo a SByte
            String número = "-19";
            var numByte1 = Convert.ToSByte(número);
            Console.WriteLine(numByte1.ToString());

            // otra manera
            numByte1 = SByte.Parse(número);

            //otra manera
            var res1 = SByte.TryParse(número, out numByte1);
            Console.WriteLine("Conversión de -19 a SByte..." + res1);

            Byte numByte2;
            var res2 = Byte.TryParse("255", out numByte2);
            Console.WriteLine("Conversión de 255 a Byte..." + res2);

            // ¿Qué pasa si excede la capacidad?
            // TryParse(): devuelve false y la variable queda con 0
            var res3 = Byte.TryParse("260", out numByte2);
            Console.WriteLine("Conversión de 260 a Byte..."+ res3);

            // ¿Qué pasa si excede la capacidad?
            // Parse(): genera una excepción OverflowException
            // quitar el comentario y habrá OverflowException!!!!

            //var res4 = Byte.Parse("260");

            // ¿Qué pasa si excede la capacidad?
            // Convert: genera una excepción OverflowException
            // si en lugar de 100 se asigna > 255 habrá excepción
            var numByte3 = Convert.ToByte("100");
            Console.WriteLine("Convert..." + numByte3.ToString());

            // Operación Inversa
            double númeroDouble = 505555.678;

            // conversión a string con formateo
            // C - moneda 1.234,56
            // C0 - moneda sin decimales 1.234
            // E - exponencial 1,234000E+004
            // E2 - exponencial 1,23E+004
            // e2 - exponencial 1,23E+004
            // F - punto fijo 123,45
            // F1 - punto fijo 123,4
            // G - general 1,234E+56
            // g2 - general 1,2e+45
            // N - número 12.345,56
            // N1 - número 12.345,6
            // P - porcentaje (x 100 y %)
            // X - Hexadecimal (11 -> 0B).
            // d - Fecha corta
            // D - Fecha larga
            // etc...

            Console.WriteLine("Double.ToString: " + númeroDouble.ToString("G"));


            // uso del parámetro cultura (configuración regional)
            Console.WriteLine("Diferentes culturas y formatos");
            Console.WriteLine("------------------------------");
            string[] culturas = { "en-US", "en-GB" };
            string[] formatos = { "C", "C1", "E2", "F3", "G2"};
            float precio = 2500.7589f;

            foreach (var cultura in culturas)
            {
                foreach (var formato in formatos)
                { 
                CultureInfo c = new CultureInfo(cultura);
                Console.WriteLine("Cultura {0}: Formato {1} : Precio {2}",
                                  c.Name,
                                  formato,
                                  precio.ToString(formato, c));
                }
                Console.WriteLine("---------");
            }

            Console.WriteLine("--fin ejemplo--");
        }
        static void U905()
        {
            Console.WriteLine("Ejemplo U905");
            Console.WriteLine("------------");
            Console.WriteLine("Búsquedas y reemplazos");
            Console.WriteLine("----------------------");

            Console.WriteLine("Prácticas de búsquedas y reemplazos");

           
            var texto1 = "Esta cadena contiene mucho texto en negrita";
            Console.WriteLine("Texto ->" + texto1);

            // comprueba si una cadena contiene
            // una subcadena o un carácter
            // devuelve true/false
            Console.WriteLine("Contains: búsqueda en cadenas");
            Console.WriteLine("Comprobación con Contains: {0} ", texto1.Contains("mucho").ToString());
            Console.WriteLine("Comprobación con Contains: {0} ", texto1.Contains("zzz").ToString());

            // Comprueba si una cadena termina con 
            // una subcadena o un carácter
            // devuelve true/false
            Console.WriteLine("EndsWith: búsqueda en cadenas");
            Console.WriteLine("Comprobación con EndsWith: {0} ", texto1.EndsWith("en negrita").ToString());
            Console.WriteLine("Comprobación con EndsWith: {0} ", texto1.EndsWith("zzz").ToString());

            // Comprueba si una cadena comienza con 
            // una subcadena o un carácter
            // devuelve true/false
            Console.WriteLine("StartsWith: búsqueda en cadenas");
            Console.WriteLine("Comprobación con StartsWith: {0} ", texto1.StartsWith("Esta").ToString());
            Console.WriteLine("Comprobación con StartsWith: {0} ", texto1.StartsWith("zzz").ToString());

            // Crea una subcadena a partir de una parte
            // de una cadena
            // indicando posición y longitud de la nueva cadena
            Console.WriteLine("Substring: creación de subcadenas");
            Console.WriteLine("Crea un substring indice 0 long 11: {0} ", texto1.Substring(0, 11));

            // Averiguar la 1ra. aparición de una subcadena o un caracter
            // si no existe esa subcadena o carácter... devolverá -1
            Console.WriteLine("IndexOf: primera aparición de una subcadena o carácter");
            Console.WriteLine("1ra aparición de la palabra mucho: {0} ", texto1.IndexOf("mucho").ToString());
            Console.WriteLine("1ra aparición de la palabra zzz: {0} ", texto1.IndexOf("zzz").ToString());

            Console.WriteLine("LastIndexOf: última aparición de una subcadena o carácter");
            // Averiguar la última aparición de una subcadena o un caracter
            // si no existe esa subcadena o carácter... devolverá -1
            Console.WriteLine("Última aparición de la letra c: {0} ", texto1.LastIndexOf('c').ToString());
            Console.WriteLine("Última aparición de la letra z: {0} ", texto1.LastIndexOf('z').ToString());

            var texto2 = "Hola amigos, soy Edgar guardar el código en la carpeta Programas";

            // Uso de Replace()
            // devuelve una nueva cadena, la cadena 
            // original no se modifica
            Console.WriteLine("Replace: reemplazo de partes de una cadena");
            // reemplaza todas las apariciones de una subcadena por otra
            var texto3 = texto2.Replace("Edgar", "el autor del libro");
            Console.WriteLine(texto3);

            // o, lo mismo, pero sin crear la variable texto3
            Console.WriteLine(texto2.Replace("Edgar", "el autor del libro")); 

            Console.WriteLine("Replace: reemplazo de caracteres en una cadena");
            // reemplaza todas las apariciones de un carácter por otro
            var texto4 = texto3.Replace('a', 'A');
            Console.WriteLine(texto4);

            Console.WriteLine("--fin ejemplo--");
        }
               
        
        static void U906()
        {
            Console.WriteLine("Ejemplo U906");
            Console.WriteLine("------------");
            Console.WriteLine("Uso de escapes");
            //Uso de escapes y de @

            // si queremos escribir esto debemos usar escapes
            // Hola amigos, soy Edgar D'Andrea (salto de línea)
            // guardar el código en la carpeta C:\Archivos\CSharp

            var nota1 = "Hola amigos, soy Edgar D\'Andrea\nguardar el código en la carpeta C:\\Archivos\\CSharp";
            Console.WriteLine(nota1);

            Console.WriteLine("Uso de @");
            // otra manera, para escribir un literal de modo natural
            // con fin de línea real (en lugar del escape \n)
            var nota2 = @"Hola amigos, soy Edgar D'Andrea
guardar el código en la carpeta C:\Archivos\CSharp";
            Console.WriteLine(nota2);

            Console.WriteLine("--fin ejemplo--");
        }
        static void U907()
        {
            Console.WriteLine("Ejemplo U907");
            Console.WriteLine("------------");
            Console.WriteLine("Creación y asignación con StringBuilder");
            // Para usar la clase StringBuilder se necesita 
            // el espacio de nombres System.Text

            // creación de un objeto StringBuilder
            var sb = new StringBuilder();

            // Asignación de contenido con Append y AppendLine
            // Append tiene 24 sobrecargas
            // para poder añadir diferentes tipos de datos
           
            sb.AppendLine("Pedro"); // añadimos un texto con nueva línea
            sb.Append(10); // añade el entero 10            
            sb.AppendLine(); // añade un fin de línea
            sb.Append(5.5f); // añade un float
            sb.Append('*', 5); // añade  5 asteriscos
            sb.AppendLine("fin");
            Console.WriteLine("Resultado de Append");
            Console.WriteLine(sb.ToString());

            // limpieza del objeto
            sb.Clear();

            // el método Append devuelve un objeto StringBuilder
            // por lo que lo anterior se pude codificar así:
            sb.AppendLine("Pedro").Append(10).AppendLine().Append(5.5f).Append('*', 5).AppendLine("fin");
            // equivalente al ejemplo anterior
            Console.WriteLine("Resultado de Append/AppendLine");
            Console.WriteLine(sb.ToString());

            // limpieza del objeto
            sb.Clear();
            // o, lo que es equivalente
            // a lo anterior... pero más legible aún
            sb
              .AppendLine("Pedro")
              .Append(10)
              .AppendLine()
              .Append(5.5f)
              .Append('*', 5)
              .AppendLine("fin");
            // equivalente al ejemplo anterior
            Console.WriteLine("Resultado de Append/AppendLine pero más legible");
            Console.WriteLine(sb.ToString());

            // Uso AppendFormat
            Console.WriteLine("AppendFormat");
            // formato numérico con 2 decimales
            var sb1 = new StringBuilder();
            sb1.AppendFormat("número {0:N2}", 2500.87556f);
            Console.WriteLine("Número con formato " + sb1);


            // Uso AppendJoin
            // une los elementos de una matriz 
            Console.WriteLine("AppendJoin: crea un objeto StringBuilder a partir de una matriz");
            string[] matriz = { "La", "casa", "amarilla", "y", "techo", "rojo" };
            var sb2 = new StringBuilder();
            sb2.AppendJoin(" ", matriz);
            Console.WriteLine(sb2);           
           
            Console.WriteLine("--fin ejemplo--");
        }
        static void U908()
        {
            Console.WriteLine("Ejemplo U908");
            Console.WriteLine("------------");
            Console.WriteLine("StringBuilder");
            Console.WriteLine("Manipulaciones: inserción, reemplazo y eliminaciones");

            var sb = new StringBuilder();
            sb
              .AppendLine("Pedro")
              .Append(10)
              .AppendLine()
              .Append(5.5f)
              .Append('*', 5)
              .AppendLine("fin");
            // equivalente al ejemplo anterior
            Console.WriteLine("Objeto sobre el que haremos manipulaciones");
            Console.WriteLine(sb.ToString());

            // Insert: inserción de partes de la cadena
            // Insert tiene 19 sobrecargas para poder
            // insertar distintos tipos de datos
            // (siempre convertidos a String)
            Console.WriteLine("Inserción de un texto intercalado");
            sb.Insert(19, "¡texto insertado!"); // insertamos en posición 19
            Console.WriteLine("Resultado de Insert");
            Console.WriteLine(sb.ToString());

            // Insertar un salto de línea
            Console.WriteLine("Inserción de un salto de línea");
            sb.Insert(19, "\n"); // insertamos un salto de línea
            Console.WriteLine("Resultado de Insert");
            Console.WriteLine(sb.ToString());

            // Replace: reemplazo de caracteres
            Console.WriteLine("Reemplazo de caracteres _ en lugar de *");
            Console.WriteLine("y reemplazo de substring Clara  en lugar de Pedro");
            sb.Replace('*', '_');
            // replace: reemplazo de substring
            sb.Replace("Pedro", "Clara");
            Console.WriteLine("Resultado de Replace");
            Console.WriteLine(sb.ToString());

            // Remove: eliminación de partes de la cadena
            Console.WriteLine("Eliminación de parte de la cadena");
            sb.Remove(0, 5); // quitamos el nombre
            Console.WriteLine("Resultado de Remove");
            Console.WriteLine(sb.ToString());

            // Inserción al principio de una cadena
            Console.WriteLine("Inserción al inicio de la cadena");
            sb.Insert(0, new string('*', 15)); // añadimos 15 asteriscos
            Console.WriteLine("Resultado de Insert");
            Console.WriteLine(sb.ToString());

            // tratamiento como matriz (igual que en la clase String)
            Console.WriteLine("El objeto StringBuilder también se puede gestionar como matriz");
            Console.WriteLine("Contenido del índice 30 del objeto StringBuilder: {0} ", sb[30]);

            Console.WriteLine("--fin ejemplo--");
        }
        static void U909()
        {
            Console.WriteLine("Ejemplo U909");
            Console.WriteLine("------------");
            Console.WriteLine("Exceso de capacidad máxima");
            // creamos un objeto que tendrá capacidad máxima 40
            // y forzaremos el exceso de capacidad
            // para provocar la excepción
            // capacidad inicial 20, máxima 40
            StringBuilder buffer = new StringBuilder(20, 100);
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine(buffer.Length);
                buffer.AppendLine("1234567890");
                // lista todo el objeto
                Console.WriteLine(buffer);
            }
            

        }




    }
}
