﻿using System;
using System.Diagnostics.CodeAnalysis;
using System.Linq.Expressions;

namespace CS_Unidad6
{
    
    class Program
    {

        static  void Main(string[] args)
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("------  CS_Unidad 6  -------");
            Console.WriteLine("----------------------------");

            // Objetivo: 
            // Comprobar que de manera predeterminada la comparación 
            // en tipos de referencia es una comparación de referencias
            // no de contenidos
            U601();

            // Objetivo: 
            // Cambiar el comportamiento predeterminado de la comparación 
            // en tipos de referencia para que sea una comparación
            // de contenidos (override de Equals)
            U602();

            // Objetivo: 
            // Mostrar que la asignación de un objeto a otro
            // en tipos de referencia lo que sucede realmente
            // es una copia de dirección de referencia        
            U603();

            // Objetivo:
            // 1) Mostrar que dos cadenas iguales creadas con new
            // no comparten referencia.
            // 2) Mostrar que cuando se modifica una cadena
            // que comparte referencia con otra (por tener
            // igual contenido) sólo se cambia la cadena
            // modificada y ya dejan de compartir referencia.
            U604();

            // Objetivo:
            // Mostrar que dos cadenas iguales creadas sin new
            // comparten referencia.
            U605();

            // Objetivo:
            // Mostrar GetHashCode()
            U606();

        }
        static void U601()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U601");
            Console.WriteLine("----------------------------");
            // Tipo de referencia
            // comparación de los objetos en general
            // dos clases con igual contenido             // 
            Persona p = new Persona();
            Persona q = new Persona();
            q.nombre = "Juan";
            p.nombre = "Juan";

            // pero en los tipos de referencia
            // -de manera predeterminada-
            // no se comparará contenido si no
            // la dirección de la referencia
            // como ambos objetos tienen diferentes
            // referencias el método Equals responde: false
            Console.WriteLine("q.nombre {0}, p.nombre {1}", q.nombre, p.nombre);
            // q.nombre Juan, p.nombre Juan
            Console.WriteLine("¿Son iguales? {0}", q.Equals(p)); // false

            // Y con el método ReferenceEquals se constata que no
            // comparten referencia
            Console.WriteLine("Los objetos p y q tienen igual referencia? " + (Persona.ReferenceEquals(p, q) ? "sí" : "no"));
        }
        static void U602()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U602");
            Console.WriteLine("----------------------------");
            // Tipo de referencia
            // La clase Persona2 tiene un método Equals
            // (que reemplaza al método virtual de la clase Object)
            // y que compara a nivel de datos lo que decida
            // el programador... en este caso, compara el campo nombre
            Persona2 p = new Persona2();
            Persona2 q = new Persona2();
            q.nombre = "Juan";
            p.nombre = "Juan";

            // El método virtual Equals modificado
            // compara campos y responde true o false
            Console.WriteLine("q.nombre {0}, p.nombre {1}", q.nombre, p.nombre);
            Console.WriteLine("¿Son iguales? {0}", q.Equals(p)); // true

            // Y con el método ReferenceEquals se constata que no
            // comparten referencia
            Console.WriteLine("Los objetos p y q tienen igual referencia? " + (Persona2.ReferenceEquals(p, q) ? "sí" : "no"));
        }
        static void U603()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U603");
            Console.WriteLine("----------------------------");
            // Creamos dos objetos de tipo Persona
            Persona p = new Persona();
            Persona r = new Persona();

            // y se asigna uno a otro
            r = p;

            // cambiaremos el objeto r
            // el objeto p parece que no se modifica
            // ... pero
            // sí que también cambiará su contenido!!!
            // porque tienen la misma referencia
            r.nombre = "Raquel";
            Console.WriteLine("r.nombre {0}, p.nombre {1} los son iguales!!!", r.nombre, p.nombre);

            // son iguales? true
            Console.WriteLine("¿Son equals? {0}", r.Equals(p)); // true

            // y tienen la misma referencia?...  más que obvio true          
            Console.WriteLine("Los objetos p y r tienen igual referencia? " + (Persona.ReferenceEquals(p, r) ? "sí" : "no"));

            // y viceversa desde p se modifica el objeto r

            p.nombre = "Carlos";
            Console.WriteLine("r.nombre {0}, p.nombre {1} los dos son iguales!!!", r.nombre, p.nombre);

            // son iguales? true
            Console.WriteLine("¿Son equals? {0}", r.Equals(p)); // true

            // y tienen la misma referencia?...  más que obvio true          
            Console.WriteLine("Los objetos p y r tienen igual referencia? " + (Persona.ReferenceEquals(p, r) ? "sí" : "no"));

        }

        static void U604()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U604");
            Console.WriteLine("----------------------------");
            //**********************
            // Asignación de Strings
            //**********************
            // Cadenas creadas con new       
            Console.WriteLine("Cadenas creadas con new");
            String str1 = new String("Susana");
            String str2 = new String("Susana");

            // comparar contenido con ==, CompareTo, Equals 
            Console.WriteLine("¿Son iguales con ==?: " + (str1 == str2 ? true : false)); // true
            Console.WriteLine("¿Son iguales con CompareTo? {0} ", str1.CompareTo(str2)); // 0 es true
            Console.WriteLine("¿Son iguales con Equals? {0}", str1.Equals(str2)); // true

            // comparar referencias
            // tienen igual contenido pero al crearse con new, 
            // tienen referencias diferentes
            Console.WriteLine("¿Tienen la misma referencia? :" + object.ReferenceEquals(str1, str2)); //FALSE

            // y se asigna un objeto a otro
            // se comparte la referencia
            str1 = str2;

            Console.WriteLine("str1  {0}, str2 {1}  son iguales?", str1, str2);

            // son iguales? true
            Console.WriteLine("¿Son equals? {0}", str1.Equals(str2)); // true

            // pero tienen la misma referencia?...  true          
            Console.WriteLine("Los objetos str1 y str2 tienen igual referencia? " + (String.ReferenceEquals(str1, str2) ? "sí" : "no"));

            // cambiaremos el objeto str2
            // y el objeto str1? cambiará o no?
            str2 = "Raquel";
            Console.WriteLine("str1  {0}, str2 {1}  son iguales?", str1, str2);

            // Ahora no son iguales ni tiene la misma referencia
            // comparar contenido con ==, CompareTo, Equals 
            Console.WriteLine("¿Son iguales con ==?: " + (str1 == str2 ? true : false)); // false
            Console.WriteLine("¿Son iguales con CompareTo? {0} ", str1.CompareTo(str2)); // 1 es false
            Console.WriteLine("¿Son iguales con Equals? {0}", str1.Equals(str2)); // false

            // comparar referencias
            Console.WriteLine("¿Tienen la misma referencia? :" + String.ReferenceEquals(str1, str2)); //FALSE
        }
        static void U605()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U605");
            Console.WriteLine("----------------------------");
            // Cadenas creadas sin new
            Console.WriteLine("Cadenas creadas sin new");
            String str3 = "Susana";
            String str4 = "Susana";

            // comparar contenido
            Console.WriteLine("¿Son iguales con == ?: " + (str3 == str4 ? true : false)); // true
            Console.WriteLine("¿Son iguales con CompareTo? {0}", str3.CompareTo(str4)); // true
            Console.WriteLine("¿Son iguales con Equals? {0}", str3.Equals(str4)); // true

            // comparar referencias
            // si los strings se hubiesen creado con new
            // tendrían referencia diferente pero en este caso
            // comparten la misma referencia
            Console.WriteLine("¿Tienen la misma referencia? :" + String.ReferenceEquals(str3, str4)); // true

            Console.WriteLine("Modificamos ambas cadenas*");
            Console.WriteLine("**** añadir un prefijo X ***********");
            str3 = "X" + str3;
            str4 = "X" + str4;

            // comparar contenido
            Console.WriteLine("¿Son iguales con == ?: " + (str3 == str4 ? true : false)); // true
            Console.WriteLine("¿Son iguales con CompareTo? {0}", str3.CompareTo(str4)); // true
            Console.WriteLine("¿Son iguales con Equals? {0}", str3.Equals(str4)); // true

            // comparar referencias
            // ya no comparten la referencia
            Console.WriteLine("¿Tienen la misma referencia? :" + String.ReferenceEquals(str3, str4)); // false
                                                                                                                     
            Console.WriteLine("***************");
             
        }

        static void U606()
        {
            Console.WriteLine("----------------------------");
            Console.WriteLine("U606");
            Console.WriteLine("----------------------------");
            // GetHashCode()
            Console.WriteLine("Creamos varios objetos y obtenemos su hashcode");
            String str5 = "¿Qué hashcode tengo? ";

            Persona p3 = new Persona();
            Persona p3bis = p3; // copiamos referencia ¿tendrá igual hashcode?

            Persona p4 = new Persona();
            
            // hashcode de los tipos de valor
            // coinciden con su valor numérico
            // siempre que el rango sea igual 
            // o menor a Int32
            int int1 = 8;

            float f1 = 3.55f;
            char ch1 = 'b';

            // ver el hashcode 
            Console.WriteLine("str5   : hashcode valor:" + str5.GetHashCode());
            Console.WriteLine("p3     : hashcode valor:" + p3.GetHashCode());
            Console.WriteLine("p3bis  : hashcode valor:" + p3bis.GetHashCode()); 
            // p3 y p3bis tienen igual referencia e igual hashcode 
            Console.WriteLine("p4     : hashcode valor:" + p4.GetHashCode());
            Console.WriteLine("int1   : hashcode valor:" + int1.GetHashCode());
            Console.WriteLine("f1     : hashcode valor:" + f1.GetHashCode());
            Console.WriteLine("ch1    : hashcode valor:" + ch1.GetHashCode());
            Console.WriteLine("***************");

        }


    }
    public class Persona
    {
        // campos, propiedades, eventos, métodos, etc.

        public string nombre;
       
    }

    public class Persona2
    {
        // campos, propiedades, eventos, métodos, etc.

        public string nombre;
        
        public override bool Equals(Object obj)
        {
            Persona2 x = (Persona2)obj;
            return nombre == x.nombre;
        }
       
    }

}
